# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AllowedAccess(BaseModel):
    """
    AllowedAccess
    """ # noqa: E501
    access_id: Optional[StrictStr] = None
    access_type: Optional[StrictStr] = None
    cluster_id: Optional[StrictInt] = None
    created_at: Optional[datetime] = None
    description: Optional[StrictStr] = None
    editable: Optional[StrictBool] = None
    error: Optional[StrictStr] = None
    id: Optional[StrictInt] = None
    is_valid: Optional[StrictBool] = None
    name: Optional[StrictStr] = None
    permissions: Optional[List[StrictStr]] = None
    sub_claims: Optional[Dict[str, List[StrictStr]]] = None
    sub_claims_case_insensitive: Optional[StrictBool] = None
    updated_at: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["access_id", "access_type", "cluster_id", "created_at", "description", "editable", "error", "id", "is_valid", "name", "permissions", "sub_claims", "sub_claims_case_insensitive", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AllowedAccess from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AllowedAccess from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_id": obj.get("access_id"),
            "access_type": obj.get("access_type"),
            "cluster_id": obj.get("cluster_id"),
            "created_at": obj.get("created_at"),
            "description": obj.get("description"),
            "editable": obj.get("editable"),
            "error": obj.get("error"),
            "id": obj.get("id"),
            "is_valid": obj.get("is_valid"),
            "name": obj.get("name"),
            "permissions": obj.get("permissions"),
            "sub_claims": obj.get("sub_claims"),
            "sub_claims_case_insensitive": obj.get("sub_claims_case_insensitive"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


