# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class AuthMethodCreateKerberos(BaseModel):
    """
    authMethodCreateKerberos is a command that creates a new auth method that will be able to authenticate using Kerberos
    """ # noqa: E501
    access_expires: Optional[StrictInt] = Field(default=0, description="Access expiration date in Unix timestamp (select 0 for access without expiry date)", alias="access-expires")
    audit_logs_claims: Optional[List[StrictStr]] = Field(default=None, description="Subclaims to include in audit logs, e.g \"--audit-logs-claims email --audit-logs-claims username\"", alias="audit-logs-claims")
    bind_dn: Optional[StrictStr] = Field(default=None, alias="bind-dn")
    bind_dn_password: Optional[StrictStr] = Field(default=None, alias="bind-dn-password")
    bound_ips: Optional[List[StrictStr]] = Field(default=None, description="A CIDR whitelist with the IPs that the access is restricted to", alias="bound-ips")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Auth Method description")
    expiration_event_in: Optional[List[StrictStr]] = Field(default=None, description="How many days before the expiration of the auth method would you like to be notified.", alias="expiration-event-in")
    force_sub_claims: Optional[StrictBool] = Field(default=None, description="if true: enforce role-association must include sub claims", alias="force-sub-claims")
    group_attr: Optional[StrictStr] = Field(default=None, alias="group-attr")
    group_dn: Optional[StrictStr] = Field(default=None, alias="group-dn")
    group_filter: Optional[StrictStr] = Field(default=None, alias="group-filter")
    gw_bound_ips: Optional[List[StrictStr]] = Field(default=None, description="A CIDR whitelist with the GW IPs that the access is restricted to", alias="gw-bound-ips")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    jwt_ttl: Optional[StrictInt] = Field(default=0, description="Jwt TTL", alias="jwt-ttl")
    keytab_file_data: Optional[StrictStr] = Field(default=None, alias="keytab-file-data")
    keytab_file_path: Optional[StrictStr] = Field(default=None, alias="keytab-file-path")
    krb5_conf_data: Optional[StrictStr] = Field(default=None, alias="krb5-conf-data")
    krb5_conf_path: Optional[StrictStr] = Field(default=None, alias="krb5-conf-path")
    ldap_anonymous_search: Optional[StrictBool] = Field(default=None, alias="ldap-anonymous-search")
    ldap_ca_cert: Optional[StrictStr] = Field(default=None, alias="ldap-ca-cert")
    ldap_url: Optional[StrictStr] = Field(default=None, alias="ldap-url")
    name: StrictStr = Field(description="Auth Method name")
    product_type: Optional[List[StrictStr]] = Field(default=None, description="Choose the relevant product type for the auth method [sm, sra, pm, dp, ca]", alias="product-type")
    subclaims_delimiters: Optional[List[StrictStr]] = Field(default=None, description="A list of additional sub claims delimiters (relevant only for SAML, OIDC, OAuth2/JWT)", alias="subclaims-delimiters")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    unique_identifier: Optional[StrictStr] = Field(default=None, description="A unique identifier (ID) value which is a \"sub claim\" name that contains details uniquely identifying that resource. This \"sub claim\" is used to distinguish between different identities.", alias="unique-identifier")
    user_attribute: Optional[StrictStr] = Field(default=None, alias="user-attribute")
    user_dn: Optional[StrictStr] = Field(default=None, alias="user-dn")
    __properties: ClassVar[List[str]] = ["access-expires", "audit-logs-claims", "bind-dn", "bind-dn-password", "bound-ips", "delete_protection", "description", "expiration-event-in", "force-sub-claims", "group-attr", "group-dn", "group-filter", "gw-bound-ips", "json", "jwt-ttl", "keytab-file-data", "keytab-file-path", "krb5-conf-data", "krb5-conf-path", "ldap-anonymous-search", "ldap-ca-cert", "ldap-url", "name", "product-type", "subclaims-delimiters", "token", "uid-token", "unique-identifier", "user-attribute", "user-dn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AuthMethodCreateKerberos from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AuthMethodCreateKerberos from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access-expires": obj.get("access-expires") if obj.get("access-expires") is not None else 0,
            "audit-logs-claims": obj.get("audit-logs-claims"),
            "bind-dn": obj.get("bind-dn"),
            "bind-dn-password": obj.get("bind-dn-password"),
            "bound-ips": obj.get("bound-ips"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "expiration-event-in": obj.get("expiration-event-in"),
            "force-sub-claims": obj.get("force-sub-claims"),
            "group-attr": obj.get("group-attr"),
            "group-dn": obj.get("group-dn"),
            "group-filter": obj.get("group-filter"),
            "gw-bound-ips": obj.get("gw-bound-ips"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "jwt-ttl": obj.get("jwt-ttl") if obj.get("jwt-ttl") is not None else 0,
            "keytab-file-data": obj.get("keytab-file-data"),
            "keytab-file-path": obj.get("keytab-file-path"),
            "krb5-conf-data": obj.get("krb5-conf-data"),
            "krb5-conf-path": obj.get("krb5-conf-path"),
            "ldap-anonymous-search": obj.get("ldap-anonymous-search"),
            "ldap-ca-cert": obj.get("ldap-ca-cert"),
            "ldap-url": obj.get("ldap-url"),
            "name": obj.get("name"),
            "product-type": obj.get("product-type"),
            "subclaims-delimiters": obj.get("subclaims-delimiters"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "unique-identifier": obj.get("unique-identifier"),
            "user-attribute": obj.get("user-attribute"),
            "user-dn": obj.get("user-dn")
        })
        return _obj


