# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class BastionListEntry(BaseModel):
    """
    BastionListEntry
    """ # noqa: E501
    access_id: Optional[StrictStr] = None
    allowed_access_ids: Optional[List[StrictStr]] = None
    allowed_urls: Optional[List[StrictStr]] = None
    allowed_urls_per_instance: Optional[Dict[str, List[StrictStr]]] = None
    bastion_ssh_port: Optional[StrictInt] = None
    bastion_urls_per_type: Optional[Dict[str, StrictStr]] = None
    cluster_name: Optional[StrictStr] = None
    display_name: Optional[StrictStr] = None
    has_gateway_identity: Optional[StrictBool] = None
    last_report: Optional[datetime] = None
    __properties: ClassVar[List[str]] = ["access_id", "allowed_access_ids", "allowed_urls", "allowed_urls_per_instance", "bastion_ssh_port", "bastion_urls_per_type", "cluster_name", "display_name", "has_gateway_identity", "last_report"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of BastionListEntry from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of BastionListEntry from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_id": obj.get("access_id"),
            "allowed_access_ids": obj.get("allowed_access_ids"),
            "allowed_urls": obj.get("allowed_urls"),
            "allowed_urls_per_instance": obj.get("allowed_urls_per_instance"),
            "bastion_ssh_port": obj.get("bastion_ssh_port"),
            "bastion_urls_per_type": obj.get("bastion_urls_per_type"),
            "cluster_name": obj.get("cluster_name"),
            "display_name": obj.get("display_name"),
            "has_gateway_identity": obj.get("has_gateway_identity"),
            "last_report": obj.get("last_report")
        })
        return _obj


