# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.pki_certificate_issue_details import PKICertificateIssueDetails
from akeyless.models.ssh_certificate_issue_details import SSHCertificateIssueDetails
from typing import Optional, Set
from typing_extensions import Self

class CertificateIssueInfo(BaseModel):
    """
    CertificateIssueInfo
    """ # noqa: E501
    cert_issuer_type: Optional[StrictStr] = None
    max_ttl: Optional[StrictInt] = None
    pki_cert_issuer_details: Optional[PKICertificateIssueDetails] = None
    ssh_cert_issuer_details: Optional[SSHCertificateIssueDetails] = None
    __properties: ClassVar[List[str]] = ["cert_issuer_type", "max_ttl", "pki_cert_issuer_details", "ssh_cert_issuer_details"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CertificateIssueInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of pki_cert_issuer_details
        if self.pki_cert_issuer_details:
            _dict['pki_cert_issuer_details'] = self.pki_cert_issuer_details.to_dict()
        # override the default output from pydantic by calling `to_dict()` of ssh_cert_issuer_details
        if self.ssh_cert_issuer_details:
            _dict['ssh_cert_issuer_details'] = self.ssh_cert_issuer_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CertificateIssueInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cert_issuer_type": obj.get("cert_issuer_type"),
            "max_ttl": obj.get("max_ttl"),
            "pki_cert_issuer_details": PKICertificateIssueDetails.from_dict(obj["pki_cert_issuer_details"]) if obj.get("pki_cert_issuer_details") is not None else None,
            "ssh_cert_issuer_details": SSHCertificateIssueDetails.from_dict(obj["ssh_cert_issuer_details"]) if obj.get("ssh_cert_issuer_details") is not None else None
        })
        return _obj


