# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateClassicKey(BaseModel):
    """
    CreateClassicKey is a command that creates classic key
    """ # noqa: E501
    alg: StrictStr = Field(description="Classic Key type; options: [AES128GCM, AES256GCM, AES128SIV, AES256SIV, RSA1024, RSA2048, RSA3072, RSA4096, EC256, EC384, GPG]")
    auto_rotate: Optional[StrictStr] = Field(default=None, description="Whether to automatically rotate every rotation_interval days, or disable existing automatic rotation [true/false]", alias="auto-rotate")
    cert_file_data: Optional[StrictStr] = Field(default=None, description="Certificate in a PEM format.", alias="cert-file-data")
    certificate_common_name: Optional[StrictStr] = Field(default=None, description="Common name for the generated certificate. Relevant only for generate-self-signed-certificate.", alias="certificate-common-name")
    certificate_country: Optional[StrictStr] = Field(default=None, description="Country name for the generated certificate. Relevant only for generate-self-signed-certificate.", alias="certificate-country")
    certificate_digest_algo: Optional[StrictStr] = Field(default=None, description="Digest algorithm to be used for the certificate key signing. Currently, we support only \"sha256\" so we hide this option for CLI.", alias="certificate-digest-algo")
    certificate_format: Optional[StrictStr] = Field(default=None, alias="certificate-format")
    certificate_locality: Optional[StrictStr] = Field(default=None, description="Locality for the generated certificate. Relevant only for generate-self-signed-certificate.", alias="certificate-locality")
    certificate_organization: Optional[StrictStr] = Field(default=None, description="Organization name for the generated certificate. Relevant only for generate-self-signed-certificate.", alias="certificate-organization")
    certificate_province: Optional[StrictStr] = Field(default=None, description="Province name for the generated certificate. Relevant only for generate-self-signed-certificate.", alias="certificate-province")
    certificate_ttl: Optional[StrictInt] = Field(default=None, description="TTL in days for the generated certificate. Required only for generate-self-signed-certificate.", alias="certificate-ttl")
    conf_file_data: Optional[StrictStr] = Field(default=None, description="The csr config data in base64 encoding", alias="conf-file-data")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    expiration_event_in: Optional[List[StrictStr]] = Field(default=None, description="How many days before the expiration of the certificate would you like to be notified.", alias="expiration-event-in")
    generate_self_signed_certificate: Optional[StrictBool] = Field(default=None, description="Whether to generate a self signed certificate with the key. If set, --certificate-ttl must be provided.", alias="generate-self-signed-certificate")
    gpg_alg: Optional[StrictStr] = Field(default=None, description="gpg alg: Relevant only if GPG key type selected; options: [RSA1024, RSA2048, RSA3072, RSA4096, Ed25519]", alias="gpg-alg")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key_data: Optional[StrictStr] = Field(default=None, description="Base64-encoded classic key value", alias="key-data")
    metadata: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    name: StrictStr = Field(description="ClassicKey name")
    protection_key_name: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)", alias="protection-key-name")
    rotation_event_in: Optional[List[StrictStr]] = Field(default=None, description="How many days before the rotation of the item would you like to be notified", alias="rotation-event-in")
    rotation_interval: Optional[StrictStr] = Field(default=None, description="The number of days to wait between every automatic rotation (1-365)", alias="rotation-interval")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["alg", "auto-rotate", "cert-file-data", "certificate-common-name", "certificate-country", "certificate-digest-algo", "certificate-format", "certificate-locality", "certificate-organization", "certificate-province", "certificate-ttl", "conf-file-data", "delete_protection", "description", "expiration-event-in", "generate-self-signed-certificate", "gpg-alg", "json", "key-data", "metadata", "name", "protection-key-name", "rotation-event-in", "rotation-interval", "tags", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateClassicKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateClassicKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alg": obj.get("alg"),
            "auto-rotate": obj.get("auto-rotate"),
            "cert-file-data": obj.get("cert-file-data"),
            "certificate-common-name": obj.get("certificate-common-name"),
            "certificate-country": obj.get("certificate-country"),
            "certificate-digest-algo": obj.get("certificate-digest-algo"),
            "certificate-format": obj.get("certificate-format"),
            "certificate-locality": obj.get("certificate-locality"),
            "certificate-organization": obj.get("certificate-organization"),
            "certificate-province": obj.get("certificate-province"),
            "certificate-ttl": obj.get("certificate-ttl"),
            "conf-file-data": obj.get("conf-file-data"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "expiration-event-in": obj.get("expiration-event-in"),
            "generate-self-signed-certificate": obj.get("generate-self-signed-certificate"),
            "gpg-alg": obj.get("gpg-alg"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key-data": obj.get("key-data"),
            "metadata": obj.get("metadata"),
            "name": obj.get("name"),
            "protection-key-name": obj.get("protection-key-name"),
            "rotation-event-in": obj.get("rotation-event-in"),
            "rotation-interval": obj.get("rotation-interval"),
            "tags": obj.get("tags"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


