# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateLdapTarget(BaseModel):
    """
    createldapTarget is a command that creates a new target. [Deprecated: Use target-create-ldap command]
    """ # noqa: E501
    bind_dn: StrictStr = Field(description="Bind DN", alias="bind-dn")
    bind_dn_password: StrictStr = Field(description="Bind DN Password", alias="bind-dn-password")
    comment: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    ldap_ca_cert: Optional[StrictStr] = Field(default=None, description="CA Certificate File Content", alias="ldap-ca-cert")
    ldap_url: StrictStr = Field(description="LDAP Server URL", alias="ldap-url")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Target name")
    server_type: Optional[StrictStr] = Field(default='OpenLDAP', description="Set Ldap server type, Options:[OpenLDAP, ActiveDirectory]. Default is OpenLDAP", alias="server-type")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    token_expiration: Optional[StrictStr] = Field(default=None, description="Token expiration", alias="token-expiration")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["bind-dn", "bind-dn-password", "comment", "description", "json", "key", "ldap-ca-cert", "ldap-url", "max-versions", "name", "server-type", "token", "token-expiration", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateLdapTarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateLdapTarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bind-dn": obj.get("bind-dn"),
            "bind-dn-password": obj.get("bind-dn-password"),
            "comment": obj.get("comment"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key": obj.get("key"),
            "ldap-ca-cert": obj.get("ldap-ca-cert"),
            "ldap-url": obj.get("ldap-url"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "server-type": obj.get("server-type") if obj.get("server-type") is not None else 'OpenLDAP',
            "token": obj.get("token"),
            "token-expiration": obj.get("token-expiration"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


