# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateNativeK8STarget(BaseModel):
    """
    createNativeK8STarget is a command that creates a new target. [Deprecated: Use target-create-k8s command]
    """ # noqa: E501
    comment: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    k8s_auth_type: Optional[StrictStr] = Field(default='token', description="K8S auth type [token/certificate]", alias="k8s-auth-type")
    k8s_client_certificate: Optional[StrictStr] = Field(default=None, description="Content of the k8 client certificate (PEM format) in a Base64 format", alias="k8s-client-certificate")
    k8s_client_key: Optional[StrictStr] = Field(default=None, description="Content of the k8 client private key (PEM format) in a Base64 format", alias="k8s-client-key")
    k8s_cluster_ca_cert: Optional[StrictStr] = Field(default=None, description="K8S cluster CA certificate", alias="k8s-cluster-ca-cert")
    k8s_cluster_endpoint: Optional[StrictStr] = Field(default=None, description="K8S cluster URL endpoint", alias="k8s-cluster-endpoint")
    k8s_cluster_name: Optional[StrictStr] = Field(default=None, description="K8S cluster name", alias="k8s-cluster-name")
    k8s_cluster_token: Optional[StrictStr] = Field(default=None, description="K8S cluster Bearer token", alias="k8s-cluster-token")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Target name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    use_gw_service_account: Optional[StrictBool] = Field(default=None, description="Use the GW's service account", alias="use-gw-service-account")
    __properties: ClassVar[List[str]] = ["comment", "description", "json", "k8s-auth-type", "k8s-client-certificate", "k8s-client-key", "k8s-cluster-ca-cert", "k8s-cluster-endpoint", "k8s-cluster-name", "k8s-cluster-token", "key", "max-versions", "name", "token", "uid-token", "use-gw-service-account"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateNativeK8STarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateNativeK8STarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "comment": obj.get("comment"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "k8s-auth-type": obj.get("k8s-auth-type") if obj.get("k8s-auth-type") is not None else 'token',
            "k8s-client-certificate": obj.get("k8s-client-certificate"),
            "k8s-client-key": obj.get("k8s-client-key"),
            "k8s-cluster-ca-cert": obj.get("k8s-cluster-ca-cert"),
            "k8s-cluster-endpoint": obj.get("k8s-cluster-endpoint"),
            "k8s-cluster-name": obj.get("k8s-cluster-name"),
            "k8s-cluster-token": obj.get("k8s-cluster-token"),
            "key": obj.get("key"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "use-gw-service-account": obj.get("use-gw-service-account")
        })
        return _obj


