# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateOidcApp(BaseModel):
    """
    CreateOidcApp
    """ # noqa: E501
    accessibility: Optional[StrictStr] = Field(default='regular', description="for personal password manager")
    audience: Optional[StrictStr] = Field(default=None, description="A comma separated list of allowed audiences")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the OIDC application (if empty, the account default protectionKey key will be used)")
    metadata: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    name: StrictStr = Field(description="OIDC application name")
    permission_assignment: Optional[StrictStr] = Field(default=None, description="A json string defining the access permission assignment for this app", alias="permission-assignment")
    public: Optional[StrictBool] = Field(default=None, description="Set to true if the app is public (cannot keep secrets)")
    redirect_uris: Optional[StrictStr] = Field(default=None, description="A comma separated list of allowed redirect uris", alias="redirect-uris")
    scopes: Optional[StrictStr] = Field(default='openid', description="A comma separated list of allowed scopes")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["accessibility", "audience", "delete_protection", "description", "json", "key", "metadata", "name", "permission-assignment", "public", "redirect-uris", "scopes", "tags", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateOidcApp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateOidcApp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessibility": obj.get("accessibility") if obj.get("accessibility") is not None else 'regular',
            "audience": obj.get("audience"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key": obj.get("key"),
            "metadata": obj.get("metadata"),
            "name": obj.get("name"),
            "permission-assignment": obj.get("permission-assignment"),
            "public": obj.get("public"),
            "redirect-uris": obj.get("redirect-uris"),
            "scopes": obj.get("scopes") if obj.get("scopes") is not None else 'openid',
            "tags": obj.get("tags"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


