# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class CreateTokenizer(BaseModel):
    """
    createTokenizer is a command that creates a tokenizer item
    """ # noqa: E501
    alphabet: Optional[StrictStr] = Field(default=None, description="Alphabet to use in regexp vaultless tokenization")
    decoding_template: Optional[StrictStr] = Field(default=None, description="The Decoding output template to use in regexp vaultless tokenization", alias="decoding-template")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    encoding_template: Optional[StrictStr] = Field(default=None, description="The Encoding output template to use in regexp vaultless tokenization", alias="encoding-template")
    encryption_key_name: Optional[StrictStr] = Field(default=None, description="AES key name to use in vaultless tokenization", alias="encryption-key-name")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    metadata: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    name: StrictStr = Field(description="Tokenizer name")
    pattern: Optional[StrictStr] = Field(default=None, description="Pattern to use in regexp vaultless tokenization")
    tag: Optional[List[StrictStr]] = Field(default=None, description="List of the tags attached to this key")
    template_type: StrictStr = Field(description="Which template type this tokenizer is used for [SSN,CreditCard,USPhoneNumber,Email,Regexp]", alias="template-type")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    tokenizer_type: StrictStr = Field(description="Tokenizer type", alias="tokenizer-type")
    tweak_type: Optional[StrictStr] = Field(default=None, description="The tweak type to use in vaultless tokenization [Supplied, Generated, Internal, Masking]", alias="tweak-type")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["alphabet", "decoding-template", "delete_protection", "description", "encoding-template", "encryption-key-name", "json", "metadata", "name", "pattern", "tag", "template-type", "token", "tokenizer-type", "tweak-type", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateTokenizer from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateTokenizer from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alphabet": obj.get("alphabet"),
            "decoding-template": obj.get("decoding-template"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "encoding-template": obj.get("encoding-template"),
            "encryption-key-name": obj.get("encryption-key-name"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "metadata": obj.get("metadata"),
            "name": obj.get("name"),
            "pattern": obj.get("pattern"),
            "tag": obj.get("tag"),
            "template-type": obj.get("template-type"),
            "token": obj.get("token"),
            "tokenizer-type": obj.get("tokenizer-type") if obj.get("tokenizer-type") is not None else 'vaultless',
            "tweak-type": obj.get("tweak-type"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


