# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DeriveKey(BaseModel):
    """
    DeriveKey
    """ # noqa: E501
    accessibility: Optional[StrictStr] = Field(default='regular', description="for personal password manager")
    alg: StrictStr = Field(description="Kdf algorithm")
    hash_function: Optional[StrictStr] = Field(default='sha256', description="HashFunction the hash function to use (relevant for pbkdf2)", alias="hash-function")
    iter: StrictInt = Field(description="IterationCount the number of iterations")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key_len: StrictInt = Field(description="KeyLength the byte length of the generated key", alias="key-len")
    mem: Optional[StrictInt] = Field(default=16384, description="MemorySizeInKb the memory paramter in kb (relevant for argon2id)")
    name: StrictStr = Field(description="Static Secret full name")
    parallelism: Optional[StrictInt] = Field(default=1, description="Parallelism the number of threads to use (relevant for argon2id)")
    salt: Optional[StrictStr] = Field(default=None, description="Salt Base64 encoded salt value. If not provided, the salt will be generated as part of the operation. The salt should be securely-generated random bytes, minimum 64 bits, 128 bits is recommended")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["accessibility", "alg", "hash-function", "iter", "json", "key-len", "mem", "name", "parallelism", "salt", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DeriveKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DeriveKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessibility": obj.get("accessibility") if obj.get("accessibility") is not None else 'regular',
            "alg": obj.get("alg") if obj.get("alg") is not None else 'pbkdf2',
            "hash-function": obj.get("hash-function") if obj.get("hash-function") is not None else 'sha256',
            "iter": obj.get("iter"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key-len": obj.get("key-len"),
            "mem": obj.get("mem") if obj.get("mem") is not None else 16384,
            "name": obj.get("name"),
            "parallelism": obj.get("parallelism") if obj.get("parallelism") is not None else 1,
            "salt": obj.get("salt"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


