# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DescribeItem(BaseModel):
    """
    DescribeItem
    """ # noqa: E501
    accessibility: Optional[StrictStr] = Field(default='regular', description="for personal password manager")
    bastion_details: Optional[StrictBool] = Field(default=False, description="Indicate if the item should return with ztb cluster details (url, etc)", alias="bastion-details")
    der_certificate_format: Optional[StrictBool] = Field(default=False, description="The certificate will be displayed in DER format", alias="der-certificate-format")
    display_id: Optional[StrictStr] = Field(default=None, description="The display id of the item", alias="display-id")
    gateway_details: Optional[StrictBool] = Field(default=False, description="Indicate if the item should return with clusters details (url, etc)", alias="gateway-details")
    item_id: Optional[StrictInt] = Field(default=None, description="Item id of the item", alias="item-id")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Item name")
    services_details: Optional[StrictBool] = Field(default=False, description="Include all associated services details", alias="services-details")
    show_versions: Optional[StrictBool] = Field(default=False, description="Include all item versions in reply", alias="show-versions")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["accessibility", "bastion-details", "der-certificate-format", "display-id", "gateway-details", "item-id", "json", "name", "services-details", "show-versions", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DescribeItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DescribeItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessibility": obj.get("accessibility") if obj.get("accessibility") is not None else 'regular',
            "bastion-details": obj.get("bastion-details") if obj.get("bastion-details") is not None else False,
            "der-certificate-format": obj.get("der-certificate-format") if obj.get("der-certificate-format") is not None else False,
            "display-id": obj.get("display-id"),
            "gateway-details": obj.get("gateway-details") if obj.get("gateway-details") is not None else False,
            "item-id": obj.get("item-id"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "services-details": obj.get("services-details") if obj.get("services-details") is not None else False,
            "show-versions": obj.get("show-versions") if obj.get("show-versions") is not None else False,
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


