# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DynamicSecretCreateSnowflake(BaseModel):
    """
    GatewayCreateProducerSnowflakeCmd is a command that creates a Snowflake dynamic secret
    """ # noqa: E501
    account: Optional[StrictStr] = Field(default=None, description="Account name")
    account_password: Optional[StrictStr] = Field(default=None, description="Database Password", alias="account-password")
    account_username: Optional[StrictStr] = Field(default=None, description="Database Username", alias="account-username")
    db_name: Optional[StrictStr] = Field(default=None, description="Database name", alias="db-name")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Dynamic secret name")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    private_key: Optional[StrictStr] = Field(default=None, description="RSA Private key (base64 encoded)", alias="private-key")
    private_key_passphrase: Optional[StrictStr] = Field(default=None, description="The Private key passphrase", alias="private-key-passphrase")
    role: Optional[StrictStr] = Field(default=None, description="User role")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='24h', description="User TTL", alias="user-ttl")
    warehouse: Optional[StrictStr] = Field(default=None, description="Warehouse name")
    __properties: ClassVar[List[str]] = ["account", "account-password", "account-username", "db-name", "delete_protection", "description", "json", "name", "password-length", "private-key", "private-key-passphrase", "role", "tags", "target-name", "token", "uid-token", "user-ttl", "warehouse"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DynamicSecretCreateSnowflake from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DynamicSecretCreateSnowflake from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account": obj.get("account"),
            "account-password": obj.get("account-password"),
            "account-username": obj.get("account-username"),
            "db-name": obj.get("db-name"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "password-length": obj.get("password-length"),
            "private-key": obj.get("private-key"),
            "private-key-passphrase": obj.get("private-key-passphrase"),
            "role": obj.get("role"),
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '24h',
            "warehouse": obj.get("warehouse")
        })
        return _obj


