# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DynamicSecretProducerInfo(BaseModel):
    """
    DynamicSecretProducerInfo The dynamic secret producer info This parameter relevant and required only in case of create update dynamic secret.
    """ # noqa: E501
    failure_message: Optional[StrictStr] = None
    gw_cluster_id: Optional[StrictInt] = None
    k8s_allowed_namespaces: Optional[StrictStr] = Field(default=None, description="Relevant only for generic k8s producer")
    k8s_dynamic_mode: Optional[StrictBool] = Field(default=None, description="Relevant only for generic k8s producer")
    producer_last_keep_alive: Optional[StrictStr] = None
    producer_metadata: Optional[StrictStr] = None
    producer_status: Optional[StrictStr] = Field(default=None, description="RotationStatus defines types of rotation Status")
    producer_type: Optional[StrictStr] = None
    user_ttl: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["failure_message", "gw_cluster_id", "k8s_allowed_namespaces", "k8s_dynamic_mode", "producer_last_keep_alive", "producer_metadata", "producer_status", "producer_type", "user_ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DynamicSecretProducerInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DynamicSecretProducerInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "failure_message": obj.get("failure_message"),
            "gw_cluster_id": obj.get("gw_cluster_id"),
            "k8s_allowed_namespaces": obj.get("k8s_allowed_namespaces"),
            "k8s_dynamic_mode": obj.get("k8s_dynamic_mode"),
            "producer_last_keep_alive": obj.get("producer_last_keep_alive"),
            "producer_metadata": obj.get("producer_metadata"),
            "producer_status": obj.get("producer_status"),
            "producer_type": obj.get("producer_type"),
            "user_ttl": obj.get("user_ttl")
        })
        return _obj


