# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DynamicSecretUpdateGcp(BaseModel):
    """
    dynamicSecretUpdateGcp is a command that updates a GCP dynamic secret
    """ # noqa: E501
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    gcp_cred_type: Optional[StrictStr] = Field(default=None, alias="gcp-cred-type")
    gcp_key: Optional[StrictStr] = Field(default=None, description="Base64-encoded service account private key text", alias="gcp-key")
    gcp_key_algo: Optional[StrictStr] = Field(default=None, description="Service account key algorithm, e.g. KEY_ALG_RSA_1024", alias="gcp-key-algo")
    gcp_sa_email: Optional[StrictStr] = Field(default=None, description="The email of the fixed service acocunt to generate keys or tokens for. (revelant for service-account-type=fixed)", alias="gcp-sa-email")
    gcp_token_scopes: Optional[StrictStr] = Field(default=None, description="Access token scopes list, e.g. scope1,scope2", alias="gcp-token-scopes")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Dynamic secret name")
    new_name: Optional[StrictStr] = Field(default=None, description="Dynamic secret name", alias="new-name")
    producer_encryption_key_name: Optional[StrictStr] = Field(default=None, description="Dynamic producer encryption key", alias="producer-encryption-key-name")
    role_binding: Optional[StrictStr] = Field(default=None, description="Role binding definitions in json format", alias="role-binding")
    service_account_type: StrictStr = Field(description="The type of the gcp dynamic secret. Options[fixed, dynamic]", alias="service-account-type")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='60m', description="User TTL", alias="user-ttl")
    __properties: ClassVar[List[str]] = ["delete_protection", "description", "gcp-cred-type", "gcp-key", "gcp-key-algo", "gcp-sa-email", "gcp-token-scopes", "json", "name", "new-name", "producer-encryption-key-name", "role-binding", "service-account-type", "tags", "target-name", "token", "uid-token", "user-ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DynamicSecretUpdateGcp from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DynamicSecretUpdateGcp from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "gcp-cred-type": obj.get("gcp-cred-type"),
            "gcp-key": obj.get("gcp-key"),
            "gcp-key-algo": obj.get("gcp-key-algo"),
            "gcp-sa-email": obj.get("gcp-sa-email"),
            "gcp-token-scopes": obj.get("gcp-token-scopes"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "producer-encryption-key-name": obj.get("producer-encryption-key-name"),
            "role-binding": obj.get("role-binding"),
            "service-account-type": obj.get("service-account-type") if obj.get("service-account-type") is not None else 'fixed',
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '60m'
        })
        return _obj


