# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class DynamicSecretUpdateRedis(BaseModel):
    """
    dynamicSecretUpdateRedis is a command that updates redis dynamic secret
    """ # noqa: E501
    acl_rules: Optional[StrictStr] = Field(default=None, description="A JSON array list of redis ACL rules to attach to the created user. For available rules see the ACL CAT command https://redis.io/commands/acl-cat By default the user will have permissions to read all keys '[\"~*\", \"+@read\"]'", alias="acl-rules")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    host: Optional[StrictStr] = Field(default='127.0.0.1', description="Redis Host")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Dynamic secret name")
    new_name: Optional[StrictStr] = Field(default=None, description="Dynamic secret name", alias="new-name")
    password: Optional[StrictStr] = Field(default=None, description="Redis Password")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    port: Optional[StrictStr] = Field(default='6379', description="Redis Port")
    producer_encryption_key_name: Optional[StrictStr] = Field(default=None, description="Dynamic producer encryption key", alias="producer-encryption-key-name")
    ssl: Optional[StrictBool] = Field(default=False, description="Enable/Disable SSL [true/false]")
    ssl_certificate: Optional[StrictStr] = Field(default=None, description="SSL CA certificate in base64 encoding generated from a trusted Certificate Authority (CA)", alias="ssl-certificate")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='60m', description="User TTL", alias="user-ttl")
    username: Optional[StrictStr] = Field(default=None, description="Redis Username")
    __properties: ClassVar[List[str]] = ["acl-rules", "delete_protection", "description", "host", "json", "name", "new-name", "password", "password-length", "port", "producer-encryption-key-name", "ssl", "ssl-certificate", "tags", "target-name", "token", "uid-token", "user-ttl", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of DynamicSecretUpdateRedis from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of DynamicSecretUpdateRedis from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "acl-rules": obj.get("acl-rules"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description"),
            "host": obj.get("host") if obj.get("host") is not None else '127.0.0.1',
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "password": obj.get("password"),
            "password-length": obj.get("password-length"),
            "port": obj.get("port") if obj.get("port") is not None else '6379',
            "producer-encryption-key-name": obj.get("producer-encryption-key-name"),
            "ssl": obj.get("ssl") if obj.get("ssl") is not None else False,
            "ssl-certificate": obj.get("ssl-certificate"),
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '60m',
            "username": obj.get("username")
        })
        return _obj


