# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ElasticsearchLogForwardingConfig(BaseModel):
    """
    ElasticsearchLogForwardingConfig
    """ # noqa: E501
    elasticsearch_api_key: Optional[StrictStr] = None
    elasticsearch_auth_type: Optional[StrictStr] = None
    elasticsearch_cloud_id: Optional[StrictStr] = None
    elasticsearch_enable_tls: Optional[StrictBool] = None
    elasticsearch_index: Optional[StrictStr] = None
    elasticsearch_nodes: Optional[StrictStr] = None
    elasticsearch_password: Optional[StrictStr] = None
    elasticsearch_server_type: Optional[StrictStr] = None
    elasticsearch_tls_certificate: Optional[StrictStr] = None
    elasticsearch_user_name: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["elasticsearch_api_key", "elasticsearch_auth_type", "elasticsearch_cloud_id", "elasticsearch_enable_tls", "elasticsearch_index", "elasticsearch_nodes", "elasticsearch_password", "elasticsearch_server_type", "elasticsearch_tls_certificate", "elasticsearch_user_name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ElasticsearchLogForwardingConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ElasticsearchLogForwardingConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "elasticsearch_api_key": obj.get("elasticsearch_api_key"),
            "elasticsearch_auth_type": obj.get("elasticsearch_auth_type"),
            "elasticsearch_cloud_id": obj.get("elasticsearch_cloud_id"),
            "elasticsearch_enable_tls": obj.get("elasticsearch_enable_tls"),
            "elasticsearch_index": obj.get("elasticsearch_index"),
            "elasticsearch_nodes": obj.get("elasticsearch_nodes"),
            "elasticsearch_password": obj.get("elasticsearch_password"),
            "elasticsearch_server_type": obj.get("elasticsearch_server_type"),
            "elasticsearch_tls_certificate": obj.get("elasticsearch_tls_certificate"),
            "elasticsearch_user_name": obj.get("elasticsearch_user_name")
        })
        return _obj


