# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class EmailPassAccessRules(BaseModel):
    """
    EmailPassAccessRules
    """ # noqa: E501
    alg: Optional[StrictStr] = None
    email: Optional[StrictStr] = Field(default=None, description="The Email value")
    enc_email_with_shared_key: Optional[StrictStr] = Field(default=None, description="EncEmailWithSharedKey is the email of this auth method, encrypted with the shared auth/uam key (for use in uam)")
    hash_pass: Optional[StrictStr] = Field(default=None, description="The password value")
    last_reset_password: Optional[datetime] = Field(default=None, description="The last password change date")
    mfa_type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["alg", "email", "enc_email_with_shared_key", "hash_pass", "last_reset_password", "mfa_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of EmailPassAccessRules from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of EmailPassAccessRules from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "alg": obj.get("alg"),
            "email": obj.get("email"),
            "enc_email_with_shared_key": obj.get("enc_email_with_shared_key"),
            "hash_pass": obj.get("hash_pass"),
            "last_reset_password": obj.get("last_reset_password"),
            "mfa_type": obj.get("mfa_type")
        })
        return _obj


