# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayCreateAllowedAccess(BaseModel):
    """
    gatewayCreateAllowedAccess is a command that creates allowed access in Gator
    """ # noqa: E501
    sub_claims_case_insensitive: Optional[StrictBool] = Field(default=None, alias="SubClaimsCaseInsensitive")
    access_id: StrictStr = Field(description="Access ID The access id to be attached to this allowed access. Auth method with this access id should already exist.", alias="access-id")
    case_sensitive: Optional[StrictStr] = Field(default='true', description="Treat sub claims as case-sensitive [true/false]", alias="case-sensitive")
    description: Optional[StrictStr] = Field(default=None, description="Allowed access description")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Allowed access name")
    permissions: Optional[StrictStr] = Field(default=None, description="Permissions  Comma-seperated list of permissions for this allowed access. Available permissions: [defaults,targets,classic_keys,automatic_migration,ldap_auth,dynamic_secret,k8s_auth,log_forwarding,zero_knowledge_encryption,rotated_secret,caching,event_forwarding,admin,kmip,general]")
    sub_claims: Optional[Dict[str, StrictStr]] = Field(default=None, description="Sub claims key/val of sub claims, e.g group=admins,developers", alias="sub-claims")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["SubClaimsCaseInsensitive", "access-id", "case-sensitive", "description", "json", "name", "permissions", "sub-claims", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayCreateAllowedAccess from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayCreateAllowedAccess from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "SubClaimsCaseInsensitive": obj.get("SubClaimsCaseInsensitive"),
            "access-id": obj.get("access-id"),
            "case-sensitive": obj.get("case-sensitive") if obj.get("case-sensitive") is not None else 'true',
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "permissions": obj.get("permissions"),
            "sub-claims": obj.get("sub-claims"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


