# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayCreateProducerEks(BaseModel):
    """
    gatewayCreateProducerEks is a command that creates eks producer [Deprecated: Use dynamic-secret-create-eks command]
    """ # noqa: E501
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    eks_access_key_id: Optional[StrictStr] = Field(default=None, description="Access Key ID", alias="eks-access-key-id")
    eks_assume_role: Optional[StrictStr] = Field(default=None, description="IAM assume role", alias="eks-assume-role")
    eks_cluster_ca_cert: Optional[StrictStr] = Field(default=None, description="EKS cluster CA certificate", alias="eks-cluster-ca-cert")
    eks_cluster_endpoint: Optional[StrictStr] = Field(default=None, description="EKS cluster URL endpoint", alias="eks-cluster-endpoint")
    eks_cluster_name: Optional[StrictStr] = Field(default=None, description="EKS cluster name", alias="eks-cluster-name")
    eks_region: Optional[StrictStr] = Field(default='us-east-2', description="Region", alias="eks-region")
    eks_secret_access_key: Optional[StrictStr] = Field(default=None, description="Secret Access Key", alias="eks-secret-access-key")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Dynamic secret name")
    producer_encryption_key_name: Optional[StrictStr] = Field(default=None, description="Dynamic producer encryption key", alias="producer-encryption-key-name")
    secure_access_allow_port_forwading: Optional[StrictBool] = Field(default=None, description="Enable Port forwarding while using CLI access", alias="secure-access-allow-port-forwading")
    secure_access_bastion_issuer: Optional[StrictStr] = Field(default=None, description="Deprecated. use secure-access-certificate-issuer", alias="secure-access-bastion-issuer")
    secure_access_certificate_issuer: Optional[StrictStr] = Field(default=None, description="Path to the SSH Certificate Issuer for your Akeyless Secure Access", alias="secure-access-certificate-issuer")
    secure_access_cluster_endpoint: Optional[StrictStr] = Field(default=None, description="The K8s cluster endpoint URL", alias="secure-access-cluster-endpoint")
    secure_access_delay: Optional[StrictInt] = Field(default=None, description="The delay duration, in seconds, to wait after generating just-in-time credentials. Accepted range: 0-120 seconds", alias="secure-access-delay")
    secure_access_enable: Optional[StrictStr] = Field(default=None, description="Enable/Disable secure remote access [true/false]", alias="secure-access-enable")
    secure_access_web: Optional[StrictBool] = Field(default=False, description="Enable Web Secure Remote Access", alias="secure-access-web")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='15m', description="User TTL", alias="user-ttl")
    __properties: ClassVar[List[str]] = ["delete_protection", "eks-access-key-id", "eks-assume-role", "eks-cluster-ca-cert", "eks-cluster-endpoint", "eks-cluster-name", "eks-region", "eks-secret-access-key", "json", "name", "producer-encryption-key-name", "secure-access-allow-port-forwading", "secure-access-bastion-issuer", "secure-access-certificate-issuer", "secure-access-cluster-endpoint", "secure-access-delay", "secure-access-enable", "secure-access-web", "tags", "target-name", "token", "uid-token", "user-ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayCreateProducerEks from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayCreateProducerEks from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "delete_protection": obj.get("delete_protection"),
            "eks-access-key-id": obj.get("eks-access-key-id"),
            "eks-assume-role": obj.get("eks-assume-role"),
            "eks-cluster-ca-cert": obj.get("eks-cluster-ca-cert"),
            "eks-cluster-endpoint": obj.get("eks-cluster-endpoint"),
            "eks-cluster-name": obj.get("eks-cluster-name"),
            "eks-region": obj.get("eks-region") if obj.get("eks-region") is not None else 'us-east-2',
            "eks-secret-access-key": obj.get("eks-secret-access-key"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "producer-encryption-key-name": obj.get("producer-encryption-key-name"),
            "secure-access-allow-port-forwading": obj.get("secure-access-allow-port-forwading"),
            "secure-access-bastion-issuer": obj.get("secure-access-bastion-issuer"),
            "secure-access-certificate-issuer": obj.get("secure-access-certificate-issuer"),
            "secure-access-cluster-endpoint": obj.get("secure-access-cluster-endpoint"),
            "secure-access-delay": obj.get("secure-access-delay"),
            "secure-access-enable": obj.get("secure-access-enable"),
            "secure-access-web": obj.get("secure-access-web") if obj.get("secure-access-web") is not None else False,
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '15m'
        })
        return _obj


