# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateDefaults(BaseModel):
    """
    gatewayUpdateDefaults is a command that updates defaults settings
    """ # noqa: E501
    cert_access_id: Optional[StrictStr] = Field(default='use-existing', description="Default Certificate access id for UI login", alias="cert-access-id")
    event_on_status_change: Optional[StrictStr] = Field(default=None, description="Trigger an event when Gateway status is changed [true/false]", alias="event-on-status-change")
    hvp_route_version: Optional[StrictInt] = Field(default=None, description="Hvp route version to use [1/2]", alias="hvp-route-version")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key: Optional[StrictStr] = Field(default='Default', description="The name of the gateway default encryption key")
    oidc_access_id: Optional[StrictStr] = Field(default='use-existing', description="Default OIDC access id for UI login", alias="oidc-access-id")
    saml_access_id: Optional[StrictStr] = Field(default='use-existing', description="Default SAML access id for UI login", alias="saml-access-id")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["cert-access-id", "event-on-status-change", "hvp-route-version", "json", "key", "oidc-access-id", "saml-access-id", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateDefaults from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateDefaults from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cert-access-id": obj.get("cert-access-id") if obj.get("cert-access-id") is not None else 'use-existing',
            "event-on-status-change": obj.get("event-on-status-change"),
            "hvp-route-version": obj.get("hvp-route-version"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key": obj.get("key") if obj.get("key") is not None else 'Default',
            "oidc-access-id": obj.get("oidc-access-id") if obj.get("oidc-access-id") is not None else 'use-existing',
            "saml-access-id": obj.get("saml-access-id") if obj.get("saml-access-id") is not None else 'use-existing',
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


