# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateItem(BaseModel):
    """
    gatewayUpdateItem is a command that updates classic key
    """ # noqa: E501
    add_tag: Optional[List[StrictStr]] = Field(default=None, description="List of the new tags that will be attached to this item", alias="add-tag")
    api_id: Optional[StrictStr] = Field(default=None, description="API ID to rotate (relevant only for rotator-type=api-key)", alias="api-id")
    api_key: Optional[StrictStr] = Field(default=None, description="API key to rotate (relevant only for rotator-type=api-key)", alias="api-key")
    app_id: Optional[StrictStr] = Field(default=None, description="ApplicationId (used in azure)", alias="app-id")
    auto_rotate: Optional[StrictStr] = Field(default=None, description="Whether to automatically rotate every --rotation-interval days, or disable existing automatic rotation [true/false]", alias="auto-rotate")
    custom_payload: Optional[StrictStr] = Field(default=None, description="Secret payload to be sent with rotation request (relevant only for rotator-type=custom)", alias="custom-payload")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default='default_metadata', description="Description of the object")
    gcp_key: Optional[StrictStr] = Field(default=None, description="Base64-encoded service account private key text", alias="gcp-key")
    gcp_service_account_email: Optional[StrictStr] = Field(default=None, description="The email of the gcp service account to rotate", alias="gcp-service-account-email")
    gcp_service_account_key_id: Optional[StrictStr] = Field(default=None, description="The key id of the gcp service account to rotate", alias="gcp-service-account-key-id")
    grace_rotation: Optional[StrictStr] = Field(default=None, description="Create a new access key without deleting the old key from AWS for backup (relevant only for AWS) [true/false]", alias="grace-rotation")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. (relevant only for --type=rotated-secret). If not set, use default according to account settings", alias="keep-prev-version")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)")
    name: StrictStr = Field(description="Item name")
    new_metadata: Optional[StrictStr] = Field(default='default_metadata', description="Deprecated - use description", alias="new-metadata")
    new_name: Optional[StrictStr] = Field(default=None, description="New item name", alias="new-name")
    new_version: Optional[StrictBool] = Field(default=None, description="Deprecated", alias="new-version")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    rm_tag: Optional[List[StrictStr]] = Field(default=None, description="List of the existent tags that will be removed from this item", alias="rm-tag")
    rotated_password: Optional[StrictStr] = Field(default=None, description="rotated-username password (relevant only for rotator-type=password)", alias="rotated-password")
    rotated_username: Optional[StrictStr] = Field(default=None, description="username to be rotated, if selected \\\"use-self-creds\\\" at rotator-creds-type, this username will try to rotate it's own password, if \\\"use-target-creds\\\" is selected, target credentials will be use to rotate the rotated-password (relevant only for rotator-type=password)", alias="rotated-username")
    rotation_event_in: Optional[List[StrictStr]] = Field(default=None, description="How many days before the rotation of the item would you like to be notified", alias="rotation-event-in")
    rotation_hour: Optional[StrictInt] = Field(default=0, description="The Rotation Hour", alias="rotation-hour")
    rotation_interval: Optional[StrictStr] = Field(default=None, description="The number of days to wait between every automatic key rotation (1-365)", alias="rotation-interval")
    rotator_creds_type: Optional[StrictStr] = Field(default='use-self-creds', description="The rotation credentials type", alias="rotator-creds-type")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    type: StrictStr = Field(description="Item type")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["add-tag", "api-id", "api-key", "app-id", "auto-rotate", "custom-payload", "delete_protection", "description", "gcp-key", "gcp-service-account-email", "gcp-service-account-key-id", "grace-rotation", "json", "keep-prev-version", "key", "name", "new-metadata", "new-name", "new-version", "password-length", "rm-tag", "rotated-password", "rotated-username", "rotation-event-in", "rotation-hour", "rotation-interval", "rotator-creds-type", "token", "type", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateItem from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateItem from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add-tag": obj.get("add-tag"),
            "api-id": obj.get("api-id"),
            "api-key": obj.get("api-key"),
            "app-id": obj.get("app-id"),
            "auto-rotate": obj.get("auto-rotate"),
            "custom-payload": obj.get("custom-payload"),
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description") if obj.get("description") is not None else 'default_metadata',
            "gcp-key": obj.get("gcp-key"),
            "gcp-service-account-email": obj.get("gcp-service-account-email"),
            "gcp-service-account-key-id": obj.get("gcp-service-account-key-id"),
            "grace-rotation": obj.get("grace-rotation"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "key": obj.get("key"),
            "name": obj.get("name"),
            "new-metadata": obj.get("new-metadata") if obj.get("new-metadata") is not None else 'default_metadata',
            "new-name": obj.get("new-name"),
            "new-version": obj.get("new-version"),
            "password-length": obj.get("password-length"),
            "rm-tag": obj.get("rm-tag"),
            "rotated-password": obj.get("rotated-password"),
            "rotated-username": obj.get("rotated-username"),
            "rotation-event-in": obj.get("rotation-event-in"),
            "rotation-hour": obj.get("rotation-hour") if obj.get("rotation-hour") is not None else 0,
            "rotation-interval": obj.get("rotation-interval"),
            "rotator-creds-type": obj.get("rotator-creds-type") if obj.get("rotator-creds-type") is not None else 'use-self-creds',
            "token": obj.get("token"),
            "type": obj.get("type"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


