# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateLdapAuthConfig(BaseModel):
    """
    gatewayUpdateLdapAuth is a command that updates ldap auth config
    """ # noqa: E501
    access_id: Optional[StrictStr] = Field(default=None, description="The access ID of the Ldap auth method", alias="access-id")
    bind_dn: Optional[StrictStr] = Field(default=None, description="Bind DN", alias="bind-dn")
    bind_dn_password: Optional[StrictStr] = Field(default=None, description="Bind DN Password", alias="bind-dn-password")
    group_attr: Optional[StrictStr] = Field(default=None, description="Group Attr", alias="group-attr")
    group_dn: Optional[StrictStr] = Field(default=None, description="Group Dn", alias="group-dn")
    group_filter: Optional[StrictStr] = Field(default=None, description="Group Filter", alias="group-filter")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    ldap_ca_cert: Optional[StrictStr] = Field(default=None, description="LDAP CA Certificate (base64 encoded)", alias="ldap-ca-cert")
    ldap_enable: Optional[StrictStr] = Field(default=None, description="Enable Ldap [true/false]", alias="ldap-enable")
    ldap_url: Optional[StrictStr] = Field(default=None, description="LDAP Server URL, e.g. ldap://planetexpress.com:389", alias="ldap-url")
    signing_key_data: Optional[StrictStr] = Field(default=None, description="The private key (base64 encoded), associated with the public key defined in the Ldap auth", alias="signing-key-data")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_attribute: Optional[StrictStr] = Field(default=None, description="User Attribute", alias="user-attribute")
    user_dn: Optional[StrictStr] = Field(default=None, description="User DN", alias="user-dn")
    __properties: ClassVar[List[str]] = ["access-id", "bind-dn", "bind-dn-password", "group-attr", "group-dn", "group-filter", "json", "ldap-ca-cert", "ldap-enable", "ldap-url", "signing-key-data", "token", "uid-token", "user-attribute", "user-dn"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateLdapAuthConfig from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateLdapAuthConfig from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access-id": obj.get("access-id"),
            "bind-dn": obj.get("bind-dn"),
            "bind-dn-password": obj.get("bind-dn-password"),
            "group-attr": obj.get("group-attr"),
            "group-dn": obj.get("group-dn"),
            "group-filter": obj.get("group-filter"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "ldap-ca-cert": obj.get("ldap-ca-cert"),
            "ldap-enable": obj.get("ldap-enable"),
            "ldap-url": obj.get("ldap-url"),
            "signing-key-data": obj.get("signing-key-data"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-attribute": obj.get("user-attribute"),
            "user-dn": obj.get("user-dn")
        })
        return _obj


