# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateLogForwardingGoogleChronicle(BaseModel):
    """
    gatewayUpdateLogForwardingGoogleChronicle is a command that updates log forwarding config (google-chronicle target)
    """ # noqa: E501
    customer_id: Optional[StrictStr] = Field(default=None, description="Google chronicle customer id", alias="customer-id")
    enable: Optional[StrictStr] = Field(default='true', description="Enable Log Forwarding [true/false]")
    gcp_key: Optional[StrictStr] = Field(default=None, description="Base64-encoded service account private key text", alias="gcp-key")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    log_type: Optional[StrictStr] = Field(default=None, description="Google chronicle log type", alias="log-type")
    output_format: Optional[StrictStr] = Field(default='text', description="Logs format [text/json]", alias="output-format")
    pull_interval: Optional[StrictStr] = Field(default='10', description="Pull interval in seconds", alias="pull-interval")
    region: Optional[StrictStr] = Field(default=None, description="Google chronicle region [eu_multi_region/london/us_multi_region/singapore/tel_aviv]")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["customer-id", "enable", "gcp-key", "json", "log-type", "output-format", "pull-interval", "region", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateLogForwardingGoogleChronicle from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateLogForwardingGoogleChronicle from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "customer-id": obj.get("customer-id"),
            "enable": obj.get("enable") if obj.get("enable") is not None else 'true',
            "gcp-key": obj.get("gcp-key"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "log-type": obj.get("log-type"),
            "output-format": obj.get("output-format") if obj.get("output-format") is not None else 'text',
            "pull-interval": obj.get("pull-interval") if obj.get("pull-interval") is not None else '10',
            "region": obj.get("region"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


