# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateMigration(BaseModel):
    """
    gatewayUpdateMigration is a command that update migration
    """ # noqa: E501
    var_1password_email: Optional[StrictStr] = Field(default=None, description="1Password user email to connect to the API", alias="1password-email")
    var_1password_password: Optional[StrictStr] = Field(default=None, description="1Password user password to connect to the API", alias="1password-password")
    var_1password_secret_key: Optional[StrictStr] = Field(default=None, description="1Password user secret key to connect to the API", alias="1password-secret-key")
    var_1password_url: Optional[StrictStr] = Field(default=None, description="1Password api container url", alias="1password-url")
    var_1password_vaults: Optional[List[StrictStr]] = Field(default=None, description="1Password list of vault to get the items from", alias="1password-vaults")
    service_account_key_decoded: Optional[StrictStr] = Field(default=None, alias="ServiceAccountKeyDecoded")
    ad_auto_rotate: Optional[StrictStr] = Field(default=None, description="Enable/Disable automatic/recurrent rotation for migrated secrets. Default is false: only manual rotation is allowed for migrated secrets. If set to true, this command should be combined with --ad-rotation-interval and --ad-rotation-hour parameters (Relevant only for Active Directory migration)", alias="ad-auto-rotate")
    ad_computer_base_dn: Optional[StrictStr] = Field(default=None, description="Distinguished Name of Computer objects (servers) to search in Active Directory e.g.: CN=Computers,DC=example,DC=com (Relevant only for Active Directory migration)", alias="ad-computer-base-dn")
    ad_discover_services: Optional[StrictStr] = Field(default='false', description="Enable/Disable discovery of Windows services from each domain server as part of the SSH/Windows Rotated Secrets. Default is false. (Relevant only for Active Directory migration)", alias="ad-discover-services")
    ad_discovery_types: Optional[List[StrictStr]] = Field(default=None, description="Set migration discovery types (domain-users, computers, local-users). (Relevant only for Active Directory migration)", alias="ad-discovery-types")
    ad_domain_name: Optional[StrictStr] = Field(default=None, description="Active Directory Domain Name (Relevant only for Active Directory migration)", alias="ad-domain-name")
    ad_domain_users_path_template: Optional[StrictStr] = Field(default=None, description="Path location template for migrating domain users as Rotated Secrets e.g.: .../DomainUsers/{{USERNAME}} (Relevant only for Active Directory migration)", alias="ad-domain-users-path-template")
    ad_local_users_ignore: Optional[StrictStr] = Field(default=None, description="Comma-separated list of Local Users which should not be migrated (Relevant only for Active Directory migration)", alias="ad-local-users-ignore")
    ad_local_users_path_template: Optional[StrictStr] = Field(default=None, description="Path location template for migrating domain users as Rotated Secrets e.g.: .../LocalUsers/{{COMPUTER_NAME}}/{{USERNAME}} (Relevant only for Active Directory migration)", alias="ad-local-users-path-template")
    ad_os_filter: Optional[StrictStr] = Field(default=None, description="Filter by Operating System to run the migration, can be used with wildcards, e.g. SRV20* (Relevant only for Active Directory migration)", alias="ad-os-filter")
    ad_rotation_hour: Optional[StrictInt] = Field(default=None, description="The hour of the scheduled rotation in UTC (Relevant only for Active Directory migration)", alias="ad-rotation-hour")
    ad_rotation_interval: Optional[StrictInt] = Field(default=None, description="The number of days to wait between every automatic rotation [1-365] (Relevant only for Active Directory migration)", alias="ad-rotation-interval")
    ad_sra_enable_rdp: Optional[StrictStr] = Field(default=None, description="Enable/Disable RDP Secure Remote Access for the migrated local users rotated secrets. Default is false: rotated secrets will not be created with SRA (Relevant only for Active Directory migration)", alias="ad-sra-enable-rdp")
    ad_ssh_port: Optional[StrictStr] = Field(default='22', description="Set the SSH Port for further connection to the domain servers. Default is port 22 (Relevant only for Active Directory migration)", alias="ad-ssh-port")
    ad_target_format: Optional[StrictStr] = Field(default='linked', description="Relevant only for ad-discovery-types=computers. For linked, all computers will be migrated into a linked target(s). if set with regular, the migration will create a target for each computer.", alias="ad-target-format")
    ad_target_name: Optional[StrictStr] = Field(default=None, description="Active Directory LDAP Target Name. Server type should be Active Directory (Relevant only for Active Directory migration)", alias="ad-target-name")
    ad_targets_path_template: Optional[StrictStr] = Field(default=None, description="Path location template for migrating domain servers as SSH/Windows Targets e.g.: .../Servers/{{COMPUTER_NAME}} (Relevant only for Active Directory migration)", alias="ad-targets-path-template")
    ad_targets_type: Optional[StrictStr] = Field(default='windows', description="Set the target type of the domain servers [ssh/windows](Relevant only for Active Directory migration)", alias="ad-targets-type")
    ad_user_base_dn: Optional[StrictStr] = Field(default=None, description="Distinguished Name of User objects to search in Active Directory, e.g.: CN=Users,DC=example,DC=com (Relevant only for Active Directory migration)", alias="ad-user-base-dn")
    ad_user_groups: Optional[StrictStr] = Field(default=None, description="Comma-separated list of domain groups from which privileged domain users will be migrated. If empty, migrate all users based on the --ad-user-base-dn (Relevant only for Active Directory migration)", alias="ad-user-groups")
    ad_winrm_over_http: Optional[StrictStr] = Field(default='false', description="Use WinRM over HTTP, by default runs over HTTPS", alias="ad-winrm-over-http")
    ad_winrm_port: Optional[StrictStr] = Field(default='5986', description="Set the WinRM Port for further connection to the domain servers. Default is 5986 (Relevant only for Active Directory migration)", alias="ad-winrm-port")
    ad_discover_local_users: Optional[StrictStr] = Field(default=None, description="Enable/Disable discovery of local users from each domain server and migrate them as SSH/Windows Rotated Secrets. Default is false: only domain users will be migrated. Discovery of local users might require further installation of SSH on the servers, based on the supplied computer base DN. This will be implemented automatically as part of the migration process (Relevant only for Active Directory migration) Deprecated: use AdDiscoverTypes")
    aws_key: Optional[StrictStr] = Field(default=None, description="AWS Secret Access Key (relevant only for AWS migration)", alias="aws-key")
    aws_key_id: Optional[StrictStr] = Field(default=None, description="AWS Access Key ID with sufficient permissions to get all secrets, e.g. 'arn:aws:secretsmanager:[Region]:[AccountId]:secret:[/path/to/secrets/*]' (relevant only for AWS migration)", alias="aws-key-id")
    aws_region: Optional[StrictStr] = Field(default='us-east-2', description="AWS region of the required Secrets Manager (relevant only for AWS migration)", alias="aws-region")
    azure_client_id: Optional[StrictStr] = Field(default=None, description="Azure Key Vault Access client ID, should be Azure AD App with a service principal (relevant only for Azure Key Vault migration)", alias="azure-client-id")
    azure_kv_name: Optional[StrictStr] = Field(default=None, description="Azure Key Vault Name (relevant only for Azure Key Vault migration)", alias="azure-kv-name")
    azure_secret: Optional[StrictStr] = Field(default=None, description="Azure Key Vault secret (relevant only for Azure Key Vault migration)", alias="azure-secret")
    azure_tenant_id: Optional[StrictStr] = Field(default=None, description="Azure Key Vault Access tenant ID (relevant only for Azure Key Vault migration)", alias="azure-tenant-id")
    gcp_key: Optional[StrictStr] = Field(default=None, description="Base64-encoded GCP Service Account private key text with sufficient permissions to Secrets Manager, Minimum required permission is Secret Manager Secret Accessor, e.g. 'roles/secretmanager.secretAccessor' (relevant only for GCP migration)", alias="gcp-key")
    hashi_json: Optional[StrictStr] = Field(default='true', description="Import secret key as json value or independent secrets (relevant only for HasiCorp Vault migration) [true/false]", alias="hashi-json")
    hashi_ns: Optional[List[StrictStr]] = Field(default=None, description="HashiCorp Vault Namespaces is a comma-separated list of namespaces which need to be imported into Akeyless Vault. For every provided namespace, all its child namespaces are imported as well, e.g. nmsp/subnmsp1/subnmsp2,nmsp/anothernmsp. By default, import all namespaces (relevant only for HasiCorp Vault migration)", alias="hashi-ns")
    hashi_token: Optional[StrictStr] = Field(default=None, description="HashiCorp Vault access token with sufficient permissions to preform list & read operations on secrets objects (relevant only for HasiCorp Vault migration)", alias="hashi-token")
    hashi_url: Optional[StrictStr] = Field(default=None, description="HashiCorp Vault API URL, e.g. https://vault-mgr01:8200 (relevant only for HasiCorp Vault migration)", alias="hashi-url")
    id: Optional[StrictStr] = Field(default=None, description="Migration ID (Can be retrieved with gateway-list-migration command)")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    k8s_ca_certificate: Optional[List[StrictInt]] = Field(default=None, description="For Certificate Authentication method K8s Cluster CA certificate (relevant only for K8s migration with Certificate Authentication method)", alias="k8s-ca-certificate")
    k8s_client_certificate: Optional[List[StrictInt]] = Field(default=None, description="K8s Client certificate with sufficient permission to list and get secrets in the namespace(s) you selected (relevant only for K8s migration with Certificate Authentication method)", alias="k8s-client-certificate")
    k8s_client_key: Optional[List[StrictInt]] = Field(default=None, description="K8s Client key (relevant only for K8s migration with Certificate Authentication method)", alias="k8s-client-key")
    k8s_namespace: Optional[StrictStr] = Field(default=None, description="K8s Namespace, Use this field to import secrets from a particular namespace only. By default, the secrets are imported from all namespaces (relevant only for K8s migration)", alias="k8s-namespace")
    k8s_password: Optional[StrictStr] = Field(default=None, description="K8s Client password (relevant only for K8s migration with Password Authentication method)", alias="k8s-password")
    k8s_skip_system: Optional[StrictBool] = Field(default=None, description="K8s Skip Control Plane Secrets, This option allows to avoid importing secrets from system namespaces (relevant only for K8s migration)", alias="k8s-skip-system")
    k8s_token: Optional[StrictStr] = Field(default=None, description="For Token Authentication method K8s Bearer Token with sufficient permission to list and get secrets in the namespace(s) you selected (relevant only for K8s migration with Token Authentication method)", alias="k8s-token")
    k8s_url: Optional[StrictStr] = Field(default=None, description="K8s API Server URL, e.g. https://k8s-api.mycompany.com:6443 (relevant only for K8s migration)", alias="k8s-url")
    k8s_username: Optional[StrictStr] = Field(default=None, description="For Password Authentication method K8s Client username with sufficient permission to list and get secrets in the namespace(s) you selected (relevant only for K8s migration with Password Authentication method)", alias="k8s-username")
    name: Optional[StrictStr] = Field(default=None, description="Migration name")
    new_name: Optional[StrictStr] = Field(default=None, description="New migration name", alias="new-name")
    protection_key: Optional[StrictStr] = Field(default=None, description="The name of the key that protects the classic key value (if empty, the account default key will be used)", alias="protection-key")
    si_auto_rotate: Optional[StrictStr] = Field(default=None, description="Enable/Disable automatic/recurrent rotation for migrated secrets. Default is false: only manual rotation is allowed for migrated secrets. If set to true, this command should be combined with --si-rotation-interval and --si-rotation-hour parameters (Relevant only for Server Inventory migration)", alias="si-auto-rotate")
    si_rotation_hour: Optional[StrictInt] = Field(default=None, description="The hour of the scheduled rotation in UTC (Relevant only for Server Inventory migration)", alias="si-rotation-hour")
    si_rotation_interval: Optional[StrictInt] = Field(default=None, description="The number of days to wait between every automatic rotation [1-365] (Relevant only for Server Inventory migration)", alias="si-rotation-interval")
    si_sra_enable_rdp: Optional[StrictStr] = Field(default='false', description="Enable/Disable RDP Secure Remote Access for the migrated local users rotated secrets. Default is false: rotated secrets will not be created with SRA (Relevant only for Server Inventory migration)", alias="si-sra-enable-rdp")
    si_target_name: StrictStr = Field(description="SSH, Windows or Linked Target Name. (Relevant only for Server Inventory migration)", alias="si-target-name")
    si_user_groups: Optional[StrictStr] = Field(default=None, description="Comma-separated list of groups to migrate users from. If empty, all users from all groups will be migrated (Relevant only for Server Inventory migration)", alias="si-user-groups")
    si_users_ignore: Optional[StrictStr] = Field(default=None, description="Comma-separated list of Local Users which should not be migrated (Relevant only for Server Inventory migration)", alias="si-users-ignore")
    si_users_path_template: StrictStr = Field(description="Path location template for migrating users as Rotated Secrets e.g.: .../Users/{{COMPUTER_NAME}}/{{USERNAME}} (Relevant only for Server Inventory migration)", alias="si-users-path-template")
    target_location: StrictStr = Field(description="Target location in Akeyless for imported secrets", alias="target-location")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["1password-email", "1password-password", "1password-secret-key", "1password-url", "1password-vaults", "ServiceAccountKeyDecoded", "ad-auto-rotate", "ad-computer-base-dn", "ad-discover-services", "ad-discovery-types", "ad-domain-name", "ad-domain-users-path-template", "ad-local-users-ignore", "ad-local-users-path-template", "ad-os-filter", "ad-rotation-hour", "ad-rotation-interval", "ad-sra-enable-rdp", "ad-ssh-port", "ad-target-format", "ad-target-name", "ad-targets-path-template", "ad-targets-type", "ad-user-base-dn", "ad-user-groups", "ad-winrm-over-http", "ad-winrm-port", "ad_discover_local_users", "aws-key", "aws-key-id", "aws-region", "azure-client-id", "azure-kv-name", "azure-secret", "azure-tenant-id", "gcp-key", "hashi-json", "hashi-ns", "hashi-token", "hashi-url", "id", "json", "k8s-ca-certificate", "k8s-client-certificate", "k8s-client-key", "k8s-namespace", "k8s-password", "k8s-skip-system", "k8s-token", "k8s-url", "k8s-username", "name", "new-name", "protection-key", "si-auto-rotate", "si-rotation-hour", "si-rotation-interval", "si-sra-enable-rdp", "si-target-name", "si-user-groups", "si-users-ignore", "si-users-path-template", "target-location", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateMigration from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateMigration from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "1password-email": obj.get("1password-email"),
            "1password-password": obj.get("1password-password"),
            "1password-secret-key": obj.get("1password-secret-key"),
            "1password-url": obj.get("1password-url"),
            "1password-vaults": obj.get("1password-vaults"),
            "ServiceAccountKeyDecoded": obj.get("ServiceAccountKeyDecoded"),
            "ad-auto-rotate": obj.get("ad-auto-rotate"),
            "ad-computer-base-dn": obj.get("ad-computer-base-dn"),
            "ad-discover-services": obj.get("ad-discover-services") if obj.get("ad-discover-services") is not None else 'false',
            "ad-discovery-types": obj.get("ad-discovery-types"),
            "ad-domain-name": obj.get("ad-domain-name"),
            "ad-domain-users-path-template": obj.get("ad-domain-users-path-template"),
            "ad-local-users-ignore": obj.get("ad-local-users-ignore"),
            "ad-local-users-path-template": obj.get("ad-local-users-path-template"),
            "ad-os-filter": obj.get("ad-os-filter"),
            "ad-rotation-hour": obj.get("ad-rotation-hour"),
            "ad-rotation-interval": obj.get("ad-rotation-interval"),
            "ad-sra-enable-rdp": obj.get("ad-sra-enable-rdp"),
            "ad-ssh-port": obj.get("ad-ssh-port") if obj.get("ad-ssh-port") is not None else '22',
            "ad-target-format": obj.get("ad-target-format") if obj.get("ad-target-format") is not None else 'linked',
            "ad-target-name": obj.get("ad-target-name"),
            "ad-targets-path-template": obj.get("ad-targets-path-template"),
            "ad-targets-type": obj.get("ad-targets-type") if obj.get("ad-targets-type") is not None else 'windows',
            "ad-user-base-dn": obj.get("ad-user-base-dn"),
            "ad-user-groups": obj.get("ad-user-groups"),
            "ad-winrm-over-http": obj.get("ad-winrm-over-http") if obj.get("ad-winrm-over-http") is not None else 'false',
            "ad-winrm-port": obj.get("ad-winrm-port") if obj.get("ad-winrm-port") is not None else '5986',
            "ad_discover_local_users": obj.get("ad_discover_local_users"),
            "aws-key": obj.get("aws-key"),
            "aws-key-id": obj.get("aws-key-id"),
            "aws-region": obj.get("aws-region") if obj.get("aws-region") is not None else 'us-east-2',
            "azure-client-id": obj.get("azure-client-id"),
            "azure-kv-name": obj.get("azure-kv-name"),
            "azure-secret": obj.get("azure-secret"),
            "azure-tenant-id": obj.get("azure-tenant-id"),
            "gcp-key": obj.get("gcp-key"),
            "hashi-json": obj.get("hashi-json") if obj.get("hashi-json") is not None else 'true',
            "hashi-ns": obj.get("hashi-ns"),
            "hashi-token": obj.get("hashi-token"),
            "hashi-url": obj.get("hashi-url"),
            "id": obj.get("id"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "k8s-ca-certificate": obj.get("k8s-ca-certificate"),
            "k8s-client-certificate": obj.get("k8s-client-certificate"),
            "k8s-client-key": obj.get("k8s-client-key"),
            "k8s-namespace": obj.get("k8s-namespace"),
            "k8s-password": obj.get("k8s-password"),
            "k8s-skip-system": obj.get("k8s-skip-system"),
            "k8s-token": obj.get("k8s-token"),
            "k8s-url": obj.get("k8s-url"),
            "k8s-username": obj.get("k8s-username"),
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "protection-key": obj.get("protection-key"),
            "si-auto-rotate": obj.get("si-auto-rotate"),
            "si-rotation-hour": obj.get("si-rotation-hour"),
            "si-rotation-interval": obj.get("si-rotation-interval"),
            "si-sra-enable-rdp": obj.get("si-sra-enable-rdp") if obj.get("si-sra-enable-rdp") is not None else 'false',
            "si-target-name": obj.get("si-target-name"),
            "si-user-groups": obj.get("si-user-groups"),
            "si-users-ignore": obj.get("si-users-ignore"),
            "si-users-path-template": obj.get("si-users-path-template"),
            "target-location": obj.get("target-location"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


