# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateProducerMongo(BaseModel):
    """
    gatewayUpdateProducerMongo is a command that updates either mongodb  producer or mongodb atlas producer [Deprecated: Use dynamic-secret-update-mongodb command]
    """ # noqa: E501
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    mongodb_atlas_api_private_key: Optional[StrictStr] = Field(default=None, description="MongoDB Atlas private key", alias="mongodb-atlas-api-private-key")
    mongodb_atlas_api_public_key: Optional[StrictStr] = Field(default=None, description="MongoDB Atlas public key", alias="mongodb-atlas-api-public-key")
    mongodb_atlas_project_id: Optional[StrictStr] = Field(default=None, description="MongoDB Atlas project ID", alias="mongodb-atlas-project-id")
    mongodb_custom_data: Optional[StrictStr] = Field(default=None, description="MongoDB custom data", alias="mongodb-custom-data")
    mongodb_default_auth_db: Optional[StrictStr] = Field(default=None, description="MongoDB server default authentication database", alias="mongodb-default-auth-db")
    mongodb_host_port: Optional[StrictStr] = Field(default=None, description="MongoDB server host and port", alias="mongodb-host-port")
    mongodb_name: Optional[StrictStr] = Field(default=None, description="MongoDB Name", alias="mongodb-name")
    mongodb_password: Optional[StrictStr] = Field(default=None, description="MongoDB server password. You will prompted to provide a password if it will not appear in CLI parameters", alias="mongodb-password")
    mongodb_roles: Optional[StrictStr] = Field(default='[]', description="MongoDB Roles", alias="mongodb-roles")
    mongodb_server_uri: Optional[StrictStr] = Field(default=None, description="MongoDB server URI", alias="mongodb-server-uri")
    mongodb_uri_options: Optional[StrictStr] = Field(default=None, description="MongoDB server URI options", alias="mongodb-uri-options")
    mongodb_username: Optional[StrictStr] = Field(default=None, description="MongoDB server username", alias="mongodb-username")
    name: StrictStr = Field(description="Dynamic secret name")
    new_name: Optional[StrictStr] = Field(default=None, description="Dynamic secret name", alias="new-name")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    producer_encryption_key_name: Optional[StrictStr] = Field(default=None, description="Encrypt producer with following key", alias="producer-encryption-key-name")
    secure_access_bastion_issuer: Optional[StrictStr] = Field(default=None, description="Deprecated. use secure-access-certificate-issuer", alias="secure-access-bastion-issuer")
    secure_access_certificate_issuer: Optional[StrictStr] = Field(default=None, description="Path to the SSH Certificate Issuer for your Akeyless Secure Access", alias="secure-access-certificate-issuer")
    secure_access_delay: Optional[StrictInt] = Field(default=None, description="The delay duration, in seconds, to wait after generating just-in-time credentials. Accepted range: 0-120 seconds", alias="secure-access-delay")
    secure_access_enable: Optional[StrictStr] = Field(default=None, description="Enable/Disable secure remote access [true/false]", alias="secure-access-enable")
    secure_access_host: Optional[List[StrictStr]] = Field(default=None, description="Target DB servers for connections (In case of Linked Target association, host(s) will inherit Linked Target hosts)", alias="secure-access-host")
    secure_access_web: Optional[StrictBool] = Field(default=False, description="Enable Web Secure Remote Access", alias="secure-access-web")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='60m', description="User TTL", alias="user-ttl")
    __properties: ClassVar[List[str]] = ["delete_protection", "json", "mongodb-atlas-api-private-key", "mongodb-atlas-api-public-key", "mongodb-atlas-project-id", "mongodb-custom-data", "mongodb-default-auth-db", "mongodb-host-port", "mongodb-name", "mongodb-password", "mongodb-roles", "mongodb-server-uri", "mongodb-uri-options", "mongodb-username", "name", "new-name", "password-length", "producer-encryption-key-name", "secure-access-bastion-issuer", "secure-access-certificate-issuer", "secure-access-delay", "secure-access-enable", "secure-access-host", "secure-access-web", "tags", "target-name", "token", "uid-token", "user-ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateProducerMongo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateProducerMongo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "delete_protection": obj.get("delete_protection"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "mongodb-atlas-api-private-key": obj.get("mongodb-atlas-api-private-key"),
            "mongodb-atlas-api-public-key": obj.get("mongodb-atlas-api-public-key"),
            "mongodb-atlas-project-id": obj.get("mongodb-atlas-project-id"),
            "mongodb-custom-data": obj.get("mongodb-custom-data"),
            "mongodb-default-auth-db": obj.get("mongodb-default-auth-db"),
            "mongodb-host-port": obj.get("mongodb-host-port"),
            "mongodb-name": obj.get("mongodb-name"),
            "mongodb-password": obj.get("mongodb-password"),
            "mongodb-roles": obj.get("mongodb-roles") if obj.get("mongodb-roles") is not None else '[]',
            "mongodb-server-uri": obj.get("mongodb-server-uri"),
            "mongodb-uri-options": obj.get("mongodb-uri-options"),
            "mongodb-username": obj.get("mongodb-username"),
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "password-length": obj.get("password-length"),
            "producer-encryption-key-name": obj.get("producer-encryption-key-name"),
            "secure-access-bastion-issuer": obj.get("secure-access-bastion-issuer"),
            "secure-access-certificate-issuer": obj.get("secure-access-certificate-issuer"),
            "secure-access-delay": obj.get("secure-access-delay"),
            "secure-access-enable": obj.get("secure-access-enable"),
            "secure-access-host": obj.get("secure-access-host"),
            "secure-access-web": obj.get("secure-access-web") if obj.get("secure-access-web") is not None else False,
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '60m'
        })
        return _obj


