# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GatewayUpdateProducerPostgreSQL(BaseModel):
    """
    gatewayUpdateProducerPostgreSQL is a command that updates postgresql producer [Deprecated: Use dynamic-secret-update-postgresql command]
    """ # noqa: E501
    creation_statements: Optional[StrictStr] = Field(default=None, description="PostgreSQL Creation statements", alias="creation-statements")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="Dynamic secret name")
    new_name: Optional[StrictStr] = Field(default=None, description="Dynamic secret name", alias="new-name")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    postgresql_db_name: Optional[StrictStr] = Field(default=None, description="PostgreSQL DB Name", alias="postgresql-db-name")
    postgresql_host: Optional[StrictStr] = Field(default='127.0.0.1', description="PostgreSQL Host", alias="postgresql-host")
    postgresql_password: Optional[StrictStr] = Field(default=None, description="PostgreSQL Password", alias="postgresql-password")
    postgresql_port: Optional[StrictStr] = Field(default='5432', description="PostgreSQL Port", alias="postgresql-port")
    postgresql_username: Optional[StrictStr] = Field(default=None, description="PostgreSQL Username", alias="postgresql-username")
    producer_encryption_key: Optional[StrictStr] = Field(default=None, description="Dynamic producer encryption key", alias="producer-encryption-key")
    revocation_statement: Optional[StrictStr] = Field(default=None, description="PostgreSQL Revocation statements", alias="revocation-statement")
    secure_access_bastion_issuer: Optional[StrictStr] = Field(default=None, description="Deprecated. use secure-access-certificate-issuer", alias="secure-access-bastion-issuer")
    secure_access_certificate_issuer: Optional[StrictStr] = Field(default=None, description="Path to the SSH Certificate Issuer for your Akeyless Secure Access", alias="secure-access-certificate-issuer")
    secure_access_db_schema: Optional[StrictStr] = Field(default=None, description="The DB schema", alias="secure-access-db-schema")
    secure_access_delay: Optional[StrictInt] = Field(default=None, description="The delay duration, in seconds, to wait after generating just-in-time credentials. Accepted range: 0-120 seconds", alias="secure-access-delay")
    secure_access_enable: Optional[StrictStr] = Field(default=None, description="Enable/Disable secure remote access [true/false]", alias="secure-access-enable")
    secure_access_host: Optional[List[StrictStr]] = Field(default=None, description="Target DB servers for connections (In case of Linked Target association, host(s) will inherit Linked Target hosts)", alias="secure-access-host")
    secure_access_web: Optional[StrictBool] = Field(default=False, description="Enable Web Secure Remote Access", alias="secure-access-web")
    ssl: Optional[StrictBool] = Field(default=False, description="Enable/Disable SSL [true/false]")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Add tags attached to this object")
    target_name: Optional[StrictStr] = Field(default=None, description="Target name", alias="target-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_ttl: Optional[StrictStr] = Field(default='60m', description="User TTL", alias="user-ttl")
    __properties: ClassVar[List[str]] = ["creation-statements", "delete_protection", "json", "name", "new-name", "password-length", "postgresql-db-name", "postgresql-host", "postgresql-password", "postgresql-port", "postgresql-username", "producer-encryption-key", "revocation-statement", "secure-access-bastion-issuer", "secure-access-certificate-issuer", "secure-access-db-schema", "secure-access-delay", "secure-access-enable", "secure-access-host", "secure-access-web", "ssl", "tags", "target-name", "token", "uid-token", "user-ttl"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GatewayUpdateProducerPostgreSQL from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GatewayUpdateProducerPostgreSQL from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "creation-statements": obj.get("creation-statements"),
            "delete_protection": obj.get("delete_protection"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "password-length": obj.get("password-length"),
            "postgresql-db-name": obj.get("postgresql-db-name"),
            "postgresql-host": obj.get("postgresql-host") if obj.get("postgresql-host") is not None else '127.0.0.1',
            "postgresql-password": obj.get("postgresql-password"),
            "postgresql-port": obj.get("postgresql-port") if obj.get("postgresql-port") is not None else '5432',
            "postgresql-username": obj.get("postgresql-username"),
            "producer-encryption-key": obj.get("producer-encryption-key"),
            "revocation-statement": obj.get("revocation-statement"),
            "secure-access-bastion-issuer": obj.get("secure-access-bastion-issuer"),
            "secure-access-certificate-issuer": obj.get("secure-access-certificate-issuer"),
            "secure-access-db-schema": obj.get("secure-access-db-schema"),
            "secure-access-delay": obj.get("secure-access-delay"),
            "secure-access-enable": obj.get("secure-access-enable"),
            "secure-access-host": obj.get("secure-access-host"),
            "secure-access-web": obj.get("secure-access-web") if obj.get("secure-access-web") is not None else False,
            "ssl": obj.get("ssl") if obj.get("ssl") is not None else False,
            "tags": obj.get("tags"),
            "target-name": obj.get("target-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-ttl": obj.get("user-ttl") if obj.get("user-ttl") is not None else '60m'
        })
        return _obj


