# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.access_permission_assignment import AccessPermissionAssignment
from typing import Optional, Set
from typing_extensions import Self

class GetGroupOutput(BaseModel):
    """
    GetGroupOutput
    """ # noqa: E501
    account_id: Optional[StrictStr] = None
    creation_date: Optional[datetime] = None
    description: Optional[StrictStr] = None
    group_alias: Optional[StrictStr] = None
    group_id: Optional[StrictStr] = None
    group_name: Optional[StrictStr] = None
    is_subclaims_with_operator: Optional[StrictBool] = None
    modification_date: Optional[datetime] = None
    user_assignments: Optional[List[AccessPermissionAssignment]] = None
    __properties: ClassVar[List[str]] = ["account_id", "creation_date", "description", "group_alias", "group_id", "group_name", "is_subclaims_with_operator", "modification_date", "user_assignments"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetGroupOutput from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in user_assignments (list)
        _items = []
        if self.user_assignments:
            for _item_user_assignments in self.user_assignments:
                if _item_user_assignments:
                    _items.append(_item_user_assignments.to_dict())
            _dict['user_assignments'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetGroupOutput from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "account_id": obj.get("account_id"),
            "creation_date": obj.get("creation_date"),
            "description": obj.get("description"),
            "group_alias": obj.get("group_alias"),
            "group_id": obj.get("group_id"),
            "group_name": obj.get("group_name"),
            "is_subclaims_with_operator": obj.get("is_subclaims_with_operator"),
            "modification_date": obj.get("modification_date"),
            "user_assignments": [AccessPermissionAssignment.from_dict(_item) for _item in obj["user_assignments"]] if obj.get("user_assignments") is not None else None
        })
        return _obj


