# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class GKETargetDetails(BaseModel):
    """
    GKETargetDetails defines details related to connecting to a GKE (Google Kubernetes Engine) target
    """ # noqa: E501
    gke_cluster_ca_certificate: Optional[StrictStr] = None
    gke_cluster_endpoint: Optional[StrictStr] = None
    gke_cluster_name: Optional[StrictStr] = None
    gke_service_account_key: Optional[StrictStr] = None
    gke_service_account_name: Optional[StrictStr] = None
    use_gw_cloud_identity: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["gke_cluster_ca_certificate", "gke_cluster_endpoint", "gke_cluster_name", "gke_service_account_key", "gke_service_account_name", "use_gw_cloud_identity"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GKETargetDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GKETargetDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "gke_cluster_ca_certificate": obj.get("gke_cluster_ca_certificate"),
            "gke_cluster_endpoint": obj.get("gke_cluster_endpoint"),
            "gke_cluster_name": obj.get("gke_cluster_name"),
            "gke_service_account_key": obj.get("gke_service_account_key"),
            "gke_service_account_name": obj.get("gke_service_account_name"),
            "use_gw_cloud_identity": obj.get("use_gw_cloud_identity")
        })
        return _obj


