# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ImportPasswords(BaseModel):
    """
    importPasswords is a command that import passwords
    """ # noqa: E501
    accessibility: Optional[StrictStr] = Field(default='personal', description="for personal password manager")
    format: Optional[StrictStr] = Field(default='LastPass', description="Password format type [LastPass/Chrome/Firefox/1password/keeper/bitwarden/dashlane]")
    import_path: StrictStr = Field(description="File path", alias="import-path")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    protection_key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)")
    target_folder: Optional[StrictStr] = Field(default='/', description="Target folder for imported passwords", alias="target-folder")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    update_mode: Optional[StrictStr] = Field(default=None, alias="update-mode")
    __properties: ClassVar[List[str]] = ["accessibility", "format", "import-path", "json", "protection_key", "target-folder", "token", "uid-token", "update-mode"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImportPasswords from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImportPasswords from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessibility": obj.get("accessibility") if obj.get("accessibility") is not None else 'personal',
            "format": obj.get("format") if obj.get("format") is not None else 'LastPass',
            "import-path": obj.get("import-path"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "protection_key": obj.get("protection_key"),
            "target-folder": obj.get("target-folder") if obj.get("target-folder") is not None else '/',
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "update-mode": obj.get("update-mode")
        })
        return _obj


