# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.remote_secret_info import RemoteSecretInfo
from typing import Optional, Set
from typing_extensions import Self

class ItemUSCSyncAssociation(BaseModel):
    """
    ItemUSCSyncAssociation includes details of usc sync associations
    """ # noqa: E501
    assoc_id: Optional[StrictStr] = None
    attributes: Optional[RemoteSecretInfo] = None
    item_id: Optional[StrictInt] = None
    item_name: Optional[StrictStr] = None
    item_type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["assoc_id", "attributes", "item_id", "item_name", "item_type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ItemUSCSyncAssociation from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of attributes
        if self.attributes:
            _dict['attributes'] = self.attributes.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ItemUSCSyncAssociation from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assoc_id": obj.get("assoc_id"),
            "attributes": RemoteSecretInfo.from_dict(obj["attributes"]) if obj.get("attributes") is not None else None,
            "item_id": obj.get("item_id"),
            "item_name": obj.get("item_name"),
            "item_type": obj.get("item_type")
        })
        return _obj


