# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.k8_s_auths_config_last_change import K8SAuthsConfigLastChange
from akeyless.models.migrations_config_last_change import MigrationsConfigLastChange
from typing import Optional, Set
from typing_extensions import Self

class LastConfigChange(BaseModel):
    """
    LastConfigChange
    """ # noqa: E501
    last_k8s_auths_change: Optional[K8SAuthsConfigLastChange] = None
    last_migrations_change: Optional[MigrationsConfigLastChange] = None
    __properties: ClassVar[List[str]] = ["last_k8s_auths_change", "last_migrations_change"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LastConfigChange from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of last_k8s_auths_change
        if self.last_k8s_auths_change:
            _dict['last_k8s_auths_change'] = self.last_k8s_auths_change.to_dict()
        # override the default output from pydantic by calling `to_dict()` of last_migrations_change
        if self.last_migrations_change:
            _dict['last_migrations_change'] = self.last_migrations_change.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LastConfigChange from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "last_k8s_auths_change": K8SAuthsConfigLastChange.from_dict(obj["last_k8s_auths_change"]) if obj.get("last_k8s_auths_change") is not None else None,
            "last_migrations_change": MigrationsConfigLastChange.from_dict(obj["last_migrations_change"]) if obj.get("last_migrations_change") is not None else None
        })
        return _obj


