# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.migration_status import MigrationStatus
from typing import Optional, Set
from typing_extensions import Self

class LastStatusInfo(BaseModel):
    """
    LastStatusInfo
    """ # noqa: E501
    migrations_status: Optional[MigrationStatus] = None
    producers_errors: Optional[Any] = None
    was_migrations_copied_to_new_table: Optional[StrictBool] = Field(default=None, description="flag to indicate migrationStatus copied to new table")
    __properties: ClassVar[List[str]] = ["migrations_status", "producers_errors", "was_migrations_copied_to_new_table"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LastStatusInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of migrations_status
        if self.migrations_status:
            _dict['migrations_status'] = self.migrations_status.to_dict()
        # set to None if producers_errors (nullable) is None
        # and model_fields_set contains the field
        if self.producers_errors is None and "producers_errors" in self.model_fields_set:
            _dict['producers_errors'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LastStatusInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "migrations_status": MigrationStatus.from_dict(obj["migrations_status"]) if obj.get("migrations_status") is not None else None,
            "producers_errors": obj.get("producers_errors"),
            "was_migrations_copied_to_new_table": obj.get("was_migrations_copied_to_new_table")
        })
        return _obj


