# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class NativeK8sTargetDetails(BaseModel):
    """
    NativeK8sTargetDetails
    """ # noqa: E501
    k8s_auth_type: Optional[StrictStr] = None
    k8s_bearer_token: Optional[StrictStr] = None
    k8s_client_cert_data: Optional[StrictStr] = Field(default=None, description="For K8s Client certificates authentication")
    k8s_client_key_data: Optional[StrictStr] = None
    k8s_cluster_ca_certificate: Optional[StrictStr] = None
    k8s_cluster_endpoint: Optional[StrictStr] = None
    k8s_cluster_name: Optional[StrictStr] = None
    use_gw_service_account: Optional[StrictBool] = None
    __properties: ClassVar[List[str]] = ["k8s_auth_type", "k8s_bearer_token", "k8s_client_cert_data", "k8s_client_key_data", "k8s_cluster_ca_certificate", "k8s_cluster_endpoint", "k8s_cluster_name", "use_gw_service_account"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of NativeK8sTargetDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of NativeK8sTargetDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "k8s_auth_type": obj.get("k8s_auth_type"),
            "k8s_bearer_token": obj.get("k8s_bearer_token"),
            "k8s_client_cert_data": obj.get("k8s_client_cert_data"),
            "k8s_client_key_data": obj.get("k8s_client_key_data"),
            "k8s_cluster_ca_certificate": obj.get("k8s_cluster_ca_certificate"),
            "k8s_cluster_endpoint": obj.get("k8s_cluster_endpoint"),
            "k8s_cluster_name": obj.get("k8s_cluster_name"),
            "use_gw_service_account": obj.get("use_gw_service_account")
        })
        return _obj


