# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.password_breach_info import PasswordBreachInfo
from akeyless.models.password_score_info import PasswordScoreInfo
from typing import Optional, Set
from typing_extensions import Self

class PasswordSecurityInfo(BaseModel):
    """
    PasswordSecurityInfo
    """ # noqa: E501
    breach_info: Optional[PasswordBreachInfo] = None
    score_info: Optional[PasswordScoreInfo] = None
    __properties: ClassVar[List[str]] = ["breach_info", "score_info"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PasswordSecurityInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of breach_info
        if self.breach_info:
            _dict['breach_info'] = self.breach_info.to_dict()
        # override the default output from pydantic by calling `to_dict()` of score_info
        if self.score_info:
            _dict['score_info'] = self.score_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PasswordSecurityInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "breach_info": PasswordBreachInfo.from_dict(obj["breach_info"]) if obj.get("breach_info") is not None else None,
            "score_info": PasswordScoreInfo.from_dict(obj["score_info"]) if obj.get("score_info") is not None else None
        })
        return _obj


