# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.role_auth_method_association import RoleAuthMethodAssociation
from akeyless.models.rules import Rules
from typing import Optional, Set
from typing_extensions import Self

class Role(BaseModel):
    """
    Role
    """ # noqa: E501
    access_date: Optional[datetime] = None
    access_date_display: Optional[StrictStr] = None
    client_permissions: Optional[List[StrictStr]] = None
    comment: Optional[StrictStr] = None
    creation_date: Optional[datetime] = None
    delete_protection: Optional[StrictBool] = None
    modification_date: Optional[datetime] = None
    role_auth_methods_assoc: Optional[List[RoleAuthMethodAssociation]] = None
    role_id: Optional[StrictInt] = None
    role_name: Optional[StrictStr] = None
    rules: Optional[Rules] = None
    __properties: ClassVar[List[str]] = ["access_date", "access_date_display", "client_permissions", "comment", "creation_date", "delete_protection", "modification_date", "role_auth_methods_assoc", "role_id", "role_name", "rules"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Role from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in role_auth_methods_assoc (list)
        _items = []
        if self.role_auth_methods_assoc:
            for _item_role_auth_methods_assoc in self.role_auth_methods_assoc:
                if _item_role_auth_methods_assoc:
                    _items.append(_item_role_auth_methods_assoc.to_dict())
            _dict['role_auth_methods_assoc'] = _items
        # override the default output from pydantic by calling `to_dict()` of rules
        if self.rules:
            _dict['rules'] = self.rules.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Role from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_date": obj.get("access_date"),
            "access_date_display": obj.get("access_date_display"),
            "client_permissions": obj.get("client_permissions"),
            "comment": obj.get("comment"),
            "creation_date": obj.get("creation_date"),
            "delete_protection": obj.get("delete_protection"),
            "modification_date": obj.get("modification_date"),
            "role_auth_methods_assoc": [RoleAuthMethodAssociation.from_dict(_item) for _item in obj["role_auth_methods_assoc"]] if obj.get("role_auth_methods_assoc") is not None else None,
            "role_id": obj.get("role_id"),
            "role_name": obj.get("role_name"),
            "rules": Rules.from_dict(obj["rules"]) if obj.get("rules") is not None else None
        })
        return _obj


