# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class RotatedSecretUpdateAws(BaseModel):
    """
    RotatedSecretUpdateAws
    """ # noqa: E501
    add_tag: Optional[List[StrictStr]] = Field(default=None, description="List of the new tags that will be attached to this item", alias="add-tag")
    api_id: Optional[StrictStr] = Field(default=None, description="API ID to rotate (relevant only for rotator-type=api-key)", alias="api-id")
    api_key: Optional[StrictStr] = Field(default=None, description="API key to rotate (relevant only for rotator-type=api-key)", alias="api-key")
    authentication_credentials: Optional[StrictStr] = Field(default='use-user-creds', description="The credentials to connect with use-user-creds/use-target-creds", alias="authentication-credentials")
    auto_rotate: Optional[StrictStr] = Field(default=None, description="Whether to automatically rotate every --rotation-interval days, or disable existing automatic rotation [true/false]", alias="auto-rotate")
    aws_region: Optional[StrictStr] = Field(default='us-east-2', description="Aws Region", alias="aws-region")
    delete_protection: Optional[StrictStr] = Field(default=None, description="Protection from accidental deletion of this object [true/false]")
    description: Optional[StrictStr] = Field(default='default_metadata', description="Description of the object")
    grace_rotation: Optional[StrictStr] = Field(default=None, description="Create a new access key without deleting the old key from AWS for backup (relevant only for AWS) [true/false]", alias="grace-rotation")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. If not set, use default according to account settings", alias="keep-prev-version")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Rotated secret name")
    new_name: Optional[StrictStr] = Field(default=None, description="New item name", alias="new-name")
    password_length: Optional[StrictStr] = Field(default=None, description="The length of the password to be generated", alias="password-length")
    rm_tag: Optional[List[StrictStr]] = Field(default=None, description="List of the existent tags that will be removed from this item", alias="rm-tag")
    rotate_after_disconnect: Optional[StrictStr] = Field(default='false', description="Rotate the value of the secret after SRA session ends [true/false]", alias="rotate-after-disconnect")
    rotation_event_in: Optional[List[StrictStr]] = Field(default=None, description="How many days before the rotation of the item would you like to be notified", alias="rotation-event-in")
    rotation_hour: Optional[StrictInt] = Field(default=None, description="The Hour of the rotation in UTC", alias="rotation-hour")
    rotation_interval: Optional[StrictStr] = Field(default=None, description="The number of days to wait between every automatic key rotation (1-365)", alias="rotation-interval")
    secure_access_aws_account_id: Optional[StrictStr] = Field(default=None, description="The AWS account id", alias="secure-access-aws-account-id")
    secure_access_aws_native_cli: Optional[StrictBool] = Field(default=None, description="The AWS native cli", alias="secure-access-aws-native-cli")
    secure_access_bastion_issuer: Optional[StrictStr] = Field(default=None, description="Deprecated. use secure-access-certificate-issuer", alias="secure-access-bastion-issuer")
    secure_access_certificate_issuer: Optional[StrictStr] = Field(default=None, description="Path to the SSH Certificate Issuer for your Akeyless Secure Access", alias="secure-access-certificate-issuer")
    secure_access_enable: Optional[StrictStr] = Field(default=None, description="Enable/Disable secure remote access [true/false]", alias="secure-access-enable")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["add-tag", "api-id", "api-key", "authentication-credentials", "auto-rotate", "aws-region", "delete_protection", "description", "grace-rotation", "json", "keep-prev-version", "key", "max-versions", "name", "new-name", "password-length", "rm-tag", "rotate-after-disconnect", "rotation-event-in", "rotation-hour", "rotation-interval", "secure-access-aws-account-id", "secure-access-aws-native-cli", "secure-access-bastion-issuer", "secure-access-certificate-issuer", "secure-access-enable", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of RotatedSecretUpdateAws from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of RotatedSecretUpdateAws from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "add-tag": obj.get("add-tag"),
            "api-id": obj.get("api-id"),
            "api-key": obj.get("api-key"),
            "authentication-credentials": obj.get("authentication-credentials") if obj.get("authentication-credentials") is not None else 'use-user-creds',
            "auto-rotate": obj.get("auto-rotate"),
            "aws-region": obj.get("aws-region") if obj.get("aws-region") is not None else 'us-east-2',
            "delete_protection": obj.get("delete_protection"),
            "description": obj.get("description") if obj.get("description") is not None else 'default_metadata',
            "grace-rotation": obj.get("grace-rotation"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "key": obj.get("key"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "password-length": obj.get("password-length"),
            "rm-tag": obj.get("rm-tag"),
            "rotate-after-disconnect": obj.get("rotate-after-disconnect") if obj.get("rotate-after-disconnect") is not None else 'false',
            "rotation-event-in": obj.get("rotation-event-in"),
            "rotation-hour": obj.get("rotation-hour"),
            "rotation-interval": obj.get("rotation-interval"),
            "secure-access-aws-account-id": obj.get("secure-access-aws-account-id"),
            "secure-access-aws-native-cli": obj.get("secure-access-aws-native-cli"),
            "secure-access-bastion-issuer": obj.get("secure-access-bastion-issuer"),
            "secure-access-certificate-issuer": obj.get("secure-access-certificate-issuer"),
            "secure-access-enable": obj.get("secure-access-enable"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


