# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.log_forwarding_config_part import LogForwardingConfigPart
from akeyless.models.ssh_bastion_session_termination import SshBastionSessionTermination
from typing import Optional, Set
from typing_extensions import Self

class SshBastionConf(BaseModel):
    """
    SshBastionConf
    """ # noqa: E501
    hide_session_recording: Optional[StrictBool] = None
    kexalgs: Optional[StrictStr] = None
    log_forwarding: Optional[LogForwardingConfigPart] = None
    session_termination: Optional[SshBastionSessionTermination] = None
    __properties: ClassVar[List[str]] = ["hide_session_recording", "kexalgs", "log_forwarding", "session_termination"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SshBastionConf from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of log_forwarding
        if self.log_forwarding:
            _dict['log_forwarding'] = self.log_forwarding.to_dict()
        # override the default output from pydantic by calling `to_dict()` of session_termination
        if self.session_termination:
            _dict['session_termination'] = self.session_termination.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SshBastionConf from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "hide_session_recording": obj.get("hide_session_recording"),
            "kexalgs": obj.get("kexalgs"),
            "log_forwarding": LogForwardingConfigPart.from_dict(obj["log_forwarding"]) if obj.get("log_forwarding") is not None else None,
            "session_termination": SshBastionSessionTermination.from_dict(obj["session_termination"]) if obj.get("session_termination") is not None else None
        })
        return _obj


