# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from akeyless.models.password_security_info import PasswordSecurityInfo
from typing import Optional, Set
from typing_extensions import Self

class StaticSecretDetailsInfo(BaseModel):
    """
    StaticSecretDetailsInfo
    """ # noqa: E501
    format: Optional[StrictStr] = Field(default=None, description="StaticSecretFormat defines the format of static secret (e.g. Text)")
    max_versions: Optional[StrictInt] = None
    notify_on_change_event: Optional[StrictBool] = None
    password_security_info: Optional[PasswordSecurityInfo] = None
    username: Optional[StrictStr] = None
    website: Optional[StrictStr] = Field(default=None, description="deprecated")
    websites: Optional[List[StrictStr]] = None
    __properties: ClassVar[List[str]] = ["format", "max_versions", "notify_on_change_event", "password_security_info", "username", "website", "websites"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of StaticSecretDetailsInfo from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of password_security_info
        if self.password_security_info:
            _dict['password_security_info'] = self.password_security_info.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of StaticSecretDetailsInfo from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "format": obj.get("format"),
            "max_versions": obj.get("max_versions"),
            "notify_on_change_event": obj.get("notify_on_change_event"),
            "password_security_info": PasswordSecurityInfo.from_dict(obj["password_security_info"]) if obj.get("password_security_info") is not None else None,
            "username": obj.get("username"),
            "website": obj.get("website"),
            "websites": obj.get("websites")
        })
        return _obj


