# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class SystemAccessCredentialsReplyObj(BaseModel):
    """
    SystemAccessCredentialsReplyObj
    """ # noqa: E501
    access_id: Optional[StrictStr] = None
    auth_creds: Optional[StrictStr] = Field(default=None, description="Temporary credentials for accessing Auth")
    expiry: Optional[StrictInt] = Field(default=None, description="Credentials expiration date")
    kfm_creds: Optional[StrictStr] = Field(default=None, description="Temporary credentials for accessing the KFMs instances")
    need_mfa_app_first_config: Optional[StrictBool] = Field(default=None, description="If the user didn't complete to configure the MFA app")
    required_mfa: Optional[StrictStr] = None
    token: Optional[StrictStr] = Field(default=None, description="Credentials tmp token")
    uam_creds: Optional[StrictStr] = Field(default=None, description="Temporary credentials for accessing the UAM service")
    __properties: ClassVar[List[str]] = ["access_id", "auth_creds", "expiry", "kfm_creds", "need_mfa_app_first_config", "required_mfa", "token", "uam_creds"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of SystemAccessCredentialsReplyObj from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of SystemAccessCredentialsReplyObj from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "access_id": obj.get("access_id"),
            "auth_creds": obj.get("auth_creds"),
            "expiry": obj.get("expiry"),
            "kfm_creds": obj.get("kfm_creds"),
            "need_mfa_app_first_config": obj.get("need_mfa_app_first_config"),
            "required_mfa": obj.get("required_mfa"),
            "token": obj.get("token"),
            "uam_creds": obj.get("uam_creds")
        })
        return _obj


