# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class TargetCreateZeroSSL(BaseModel):
    """
    targetCreateZeroSSL is a command that creates a new ZeroSSL target
    """ # noqa: E501
    api_key: StrictStr = Field(description="API Key of the ZeroSSLTarget account", alias="api-key")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    imap_fqdn: StrictStr = Field(description="ImapFQDN of the IMAP service, FQDN or IPv4 address. Must be FQDN if the IMAP is using TLS", alias="imap-fqdn")
    imap_password: StrictStr = Field(description="ImapPassword to access the IMAP service", alias="imap-password")
    imap_port: Optional[StrictStr] = Field(default='993', description="ImapPort of the IMAP service", alias="imap-port")
    imap_target_email: Optional[StrictStr] = Field(default=None, description="ImapValidationEmail to use when asking ZeroSSL to send a validation email, if empty will user imap-username", alias="imap-target-email")
    imap_username: StrictStr = Field(description="ImapUsername to access the IMAP service", alias="imap-username")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Target name")
    timeout: Optional[StrictStr] = Field(default='5m', description="Timeout waiting for certificate validation in Duration format (1h - 1 Hour, 20m - 20 Minutes, 33m3s - 33 Minutes and 3 Seconds), maximum 1h.")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    __properties: ClassVar[List[str]] = ["api-key", "description", "imap-fqdn", "imap-password", "imap-port", "imap-target-email", "imap-username", "json", "key", "max-versions", "name", "timeout", "token", "uid-token"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of TargetCreateZeroSSL from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of TargetCreateZeroSSL from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api-key": obj.get("api-key"),
            "description": obj.get("description"),
            "imap-fqdn": obj.get("imap-fqdn"),
            "imap-password": obj.get("imap-password"),
            "imap-port": obj.get("imap-port") if obj.get("imap-port") is not None else '993',
            "imap-target-email": obj.get("imap-target-email"),
            "imap-username": obj.get("imap-username"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "key": obj.get("key"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "timeout": obj.get("timeout") if obj.get("timeout") is not None else '5m',
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token")
        })
        return _obj


