# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UidCreateChildToken(BaseModel):
    """
    uidCreateChildToken is a command that creates a new child token using Akeyless Universal Identity.
    """ # noqa: E501
    auth_method_name: Optional[StrictStr] = Field(default=None, description="The universal identity auth method name, required only when uid-token is not provided", alias="auth-method-name")
    child_deny_inheritance: Optional[StrictBool] = Field(default=None, description="Deny from new child to create their own children", alias="child-deny-inheritance")
    child_deny_rotate: Optional[StrictBool] = Field(default=None, description="Deny from new child to rotate", alias="child-deny-rotate")
    child_ttl: Optional[StrictInt] = Field(default=None, description="New child token ttl", alias="child-ttl")
    comment: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    uid_token_id: Optional[StrictStr] = Field(default=None, description="The ID of the uid-token, required only when uid-token is not provided", alias="uid-token-id")
    __properties: ClassVar[List[str]] = ["auth-method-name", "child-deny-inheritance", "child-deny-rotate", "child-ttl", "comment", "description", "json", "token", "uid-token", "uid-token-id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UidCreateChildToken from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UidCreateChildToken from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "auth-method-name": obj.get("auth-method-name"),
            "child-deny-inheritance": obj.get("child-deny-inheritance"),
            "child-deny-rotate": obj.get("child-deny-rotate"),
            "child-ttl": obj.get("child-ttl"),
            "comment": obj.get("comment"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "uid-token-id": obj.get("uid-token-id")
        })
        return _obj


