# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UidRotateToken(BaseModel):
    """
    uidRotateToken is a command that rotates an Akeyless Universal Identity token.
    """ # noqa: E501
    fork: Optional[StrictBool] = Field(default=None, description="Create a new child token with default parameters")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    send_manual_ack_token: Optional[StrictStr] = Field(default=None, description="The new rotated token to send manual ack for (with uid-token=the-orig-token)", alias="send-manual-ack-token")
    uid_token: Optional[StrictStr] = Field(default=None, description="The Universal identity token", alias="uid-token")
    with_manual_ack: Optional[StrictBool] = Field(default=None, description="Disable automatic ack", alias="with-manual-ack")
    __properties: ClassVar[List[str]] = ["fork", "json", "send-manual-ack-token", "uid-token", "with-manual-ack"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UidRotateToken from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UidRotateToken from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "fork": obj.get("fork"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "send-manual-ack-token": obj.get("send-manual-ack-token"),
            "uid-token": obj.get("uid-token"),
            "with-manual-ack": obj.get("with-manual-ack")
        })
        return _obj


