# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class Update(BaseModel):
    """
    Update
    """ # noqa: E501
    artifact_repository: Optional[StrictStr] = Field(default=None, description="Alternative CLI repository url. e.g. https://artifacts.site2.akeyless.io", alias="artifact-repository")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    show_changelog: Optional[StrictBool] = Field(default=None, description="Show the changelog between the current version and the latest one and exit (update will not be performed)", alias="show-changelog")
    version: Optional[StrictStr] = Field(default='latest', description="The CLI version")
    __properties: ClassVar[List[str]] = ["artifact-repository", "json", "show-changelog", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Update from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Update from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "artifact-repository": obj.get("artifact-repository"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "show-changelog": obj.get("show-changelog"),
            "version": obj.get("version") if obj.get("version") is not None else 'latest'
        })
        return _obj


