# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateDBTargetDetails(BaseModel):
    """
    UpdateDBTargetDetails
    """ # noqa: E501
    db_type: Optional[StrictStr] = Field(default=None, alias="db-type")
    host: Optional[StrictStr] = None
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. If not set, use default according to account settings", alias="keep-prev-version")
    mongo_db_name: Optional[StrictStr] = Field(default=None, alias="mongo-db-name")
    mongo_uri: Optional[StrictStr] = Field(default=None, alias="mongo-uri")
    name: StrictStr = Field(description="Target name")
    new_version: Optional[StrictBool] = Field(default=None, description="Deprecated", alias="new-version")
    port: Optional[StrictStr] = None
    protection_key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    pwd: Optional[StrictStr] = None
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_name: Optional[StrictStr] = Field(default=None, alias="user-name")
    __properties: ClassVar[List[str]] = ["db-type", "host", "json", "keep-prev-version", "mongo-db-name", "mongo-uri", "name", "new-version", "port", "protection_key", "pwd", "token", "uid-token", "user-name"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateDBTargetDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateDBTargetDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "db-type": obj.get("db-type"),
            "host": obj.get("host"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "mongo-db-name": obj.get("mongo-db-name"),
            "mongo-uri": obj.get("mongo-uri"),
            "name": obj.get("name"),
            "new-version": obj.get("new-version"),
            "port": obj.get("port"),
            "protection_key": obj.get("protection_key"),
            "pwd": obj.get("pwd"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-name": obj.get("user-name")
        })
        return _obj


