# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateEventForwarder(BaseModel):
    """
    updateEventForwarder is a command that updates an event forwarder [Deprecated - please use event-forwarder-update-* command]
    """ # noqa: E501
    admin_name: Optional[StrictStr] = Field(default=None, description="Workstation Admin Name", alias="admin-name")
    auth_type: Optional[StrictStr] = Field(default='user-pass', description="The authentication type to use when connecting to ServiceNow (user-pass / jwt)", alias="auth-type")
    client_id: Optional[StrictStr] = Field(default=None, description="The client ID to use when connecting to ServiceNow with jwt authentication", alias="client-id")
    description: Optional[StrictStr] = Field(default='default_comment', description="Description of the object")
    email_to: Optional[StrictStr] = Field(default=None, description="A comma seperated list of email addresses to send event to (relevant only for \"email\" Event Forwarder)", alias="email-to")
    enable: Optional[StrictStr] = Field(default='true', description="Enable/Disable Event Forwarder [true/false]")
    event_source_locations: Optional[List[StrictStr]] = Field(default=None, description="Event sources", alias="event-source-locations")
    event_types: Optional[List[StrictStr]] = Field(default=None, description="Event types", alias="event-types")
    host: Optional[StrictStr] = Field(default=None, description="Workstation Host")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="EventForwarder name")
    new_comment: Optional[StrictStr] = Field(default='default_comment', description="Deprecated - use description", alias="new-comment")
    new_name: Optional[StrictStr] = Field(default=None, description="New EventForwarder name", alias="new-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    user_email: Optional[StrictStr] = Field(default=None, description="The user email to use when connecting to ServiceNow with jwt authentication", alias="user-email")
    __properties: ClassVar[List[str]] = ["admin-name", "auth-type", "client-id", "description", "email-to", "enable", "event-source-locations", "event-types", "host", "json", "name", "new-comment", "new-name", "token", "uid-token", "user-email"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateEventForwarder from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateEventForwarder from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "admin-name": obj.get("admin-name"),
            "auth-type": obj.get("auth-type") if obj.get("auth-type") is not None else 'user-pass',
            "client-id": obj.get("client-id"),
            "description": obj.get("description") if obj.get("description") is not None else 'default_comment',
            "email-to": obj.get("email-to"),
            "enable": obj.get("enable") if obj.get("enable") is not None else 'true',
            "event-source-locations": obj.get("event-source-locations"),
            "event-types": obj.get("event-types"),
            "host": obj.get("host"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "new-comment": obj.get("new-comment") if obj.get("new-comment") is not None else 'default_comment',
            "new-name": obj.get("new-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "user-email": obj.get("user-email")
        })
        return _obj


