# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateGKETarget(BaseModel):
    """
    updateGKETarget is a command that updates an existing target. [Deprecated: Use target-update-gke command]
    """ # noqa: E501
    comment: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    gke_account_key: Optional[StrictStr] = Field(default=None, description="GKE Service Account key file path", alias="gke-account-key")
    gke_cluster_cert: Optional[StrictStr] = Field(default=None, description="GKE cluster CA certificate", alias="gke-cluster-cert")
    gke_cluster_endpoint: Optional[StrictStr] = Field(default=None, description="GKE cluster URL endpoint", alias="gke-cluster-endpoint")
    gke_cluster_name: Optional[StrictStr] = Field(default=None, description="GKE cluster name", alias="gke-cluster-name")
    gke_service_account_email: Optional[StrictStr] = Field(default=None, description="GKE service account email", alias="gke-service-account-email")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. If not set, use default according to account settings", alias="keep-prev-version")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Target name")
    new_name: Optional[StrictStr] = Field(default=None, description="New target name", alias="new-name")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    update_version: Optional[StrictBool] = Field(default=None, description="Deprecated", alias="update-version")
    use_gw_cloud_identity: Optional[StrictBool] = Field(default=None, alias="use-gw-cloud-identity")
    __properties: ClassVar[List[str]] = ["comment", "description", "gke-account-key", "gke-cluster-cert", "gke-cluster-endpoint", "gke-cluster-name", "gke-service-account-email", "json", "keep-prev-version", "key", "max-versions", "name", "new-name", "token", "uid-token", "update-version", "use-gw-cloud-identity"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateGKETarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateGKETarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "comment": obj.get("comment"),
            "description": obj.get("description"),
            "gke-account-key": obj.get("gke-account-key"),
            "gke-cluster-cert": obj.get("gke-cluster-cert"),
            "gke-cluster-endpoint": obj.get("gke-cluster-endpoint"),
            "gke-cluster-name": obj.get("gke-cluster-name"),
            "gke-service-account-email": obj.get("gke-service-account-email"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "key": obj.get("key"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "update-version": obj.get("update-version"),
            "use-gw-cloud-identity": obj.get("use-gw-cloud-identity")
        })
        return _obj


