# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateGlobalSignTarget(BaseModel):
    """
    updateGlobalSignTarget is a command that updates an existing target. [Deprecated: Use target-update-globalsign command]
    """ # noqa: E501
    comment: Optional[StrictStr] = Field(default=None, description="Deprecated - use description")
    contact_email: StrictStr = Field(description="Email of the GlobalSign GCC account contact", alias="contact-email")
    contact_first_name: StrictStr = Field(description="First name of the GlobalSign GCC account contact", alias="contact-first-name")
    contact_last_name: StrictStr = Field(description="Last name of the GlobalSign GCC account contact", alias="contact-last-name")
    contact_phone: StrictStr = Field(description="Telephone of the GlobalSign GCC account contact", alias="contact-phone")
    description: Optional[StrictStr] = Field(default=None, description="Description of the object")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. If not set, use default according to account settings", alias="keep-prev-version")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the target secret value (if empty, the account default protectionKey key will be used)")
    max_versions: Optional[StrictStr] = Field(default=None, description="Set the maximum number of versions, limited by the account settings defaults.", alias="max-versions")
    name: StrictStr = Field(description="Target name")
    new_name: Optional[StrictStr] = Field(default=None, description="New target name", alias="new-name")
    password: StrictStr = Field(description="Password of the GlobalSign GCC account")
    profile_id: StrictStr = Field(description="Profile ID of the GlobalSign GCC account", alias="profile-id")
    timeout: Optional[StrictStr] = Field(default='5m', description="Timeout waiting for certificate validation in Duration format (1h - 1 Hour, 20m - 20 Minutes, 33m3s - 33 Minutes and 3 Seconds), maximum 1h.")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    update_version: Optional[StrictBool] = Field(default=None, description="Deprecated", alias="update-version")
    username: StrictStr = Field(description="Username of the GlobalSign GCC account")
    __properties: ClassVar[List[str]] = ["comment", "contact-email", "contact-first-name", "contact-last-name", "contact-phone", "description", "json", "keep-prev-version", "key", "max-versions", "name", "new-name", "password", "profile-id", "timeout", "token", "uid-token", "update-version", "username"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateGlobalSignTarget from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateGlobalSignTarget from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "comment": obj.get("comment"),
            "contact-email": obj.get("contact-email"),
            "contact-first-name": obj.get("contact-first-name"),
            "contact-last-name": obj.get("contact-last-name"),
            "contact-phone": obj.get("contact-phone"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "key": obj.get("key"),
            "max-versions": obj.get("max-versions"),
            "name": obj.get("name"),
            "new-name": obj.get("new-name"),
            "password": obj.get("password"),
            "profile-id": obj.get("profile-id"),
            "timeout": obj.get("timeout") if obj.get("timeout") is not None else '5m',
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "update-version": obj.get("update-version"),
            "username": obj.get("username")
        })
        return _obj


