# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UpdateSecretVal(BaseModel):
    """
    UpdateSecretVal
    """ # noqa: E501
    accessibility: Optional[StrictStr] = Field(default='regular', description="for personal password manager")
    custom_field: Optional[Dict[str, StrictStr]] = Field(default=None, description="For Password Management use, additional fields", alias="custom-field")
    format: Optional[StrictStr] = Field(default='text', description="Secret format [text/json/key-value] (relevant only for type 'generic')")
    inject_url: Optional[List[StrictStr]] = Field(default=None, description="For Password Management use, reflect the website context", alias="inject-url")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    keep_prev_version: Optional[StrictStr] = Field(default=None, description="Whether to keep previous version [true/false]. If not set, use default according to account settings", alias="keep-prev-version")
    key: Optional[StrictStr] = Field(default=None, description="The name of a key that used to encrypt the secret value (if empty, the account default protectionKey key will be used)")
    last_version: Optional[StrictInt] = Field(default=None, description="The last version number before the update", alias="last-version")
    multiline: Optional[StrictBool] = Field(default=None, description="The provided value is a multiline value (separated by '\\n')")
    name: StrictStr = Field(description="Secret name")
    new_version: Optional[StrictBool] = Field(default=None, description="Deprecated", alias="new-version")
    password: Optional[StrictStr] = Field(default=None, description="For Password Management use, additional fields")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    username: Optional[StrictStr] = Field(default=None, description="For Password Management use")
    value: StrictStr = Field(description="The secret value (relevant only for type 'generic')")
    __properties: ClassVar[List[str]] = ["accessibility", "custom-field", "format", "inject-url", "json", "keep-prev-version", "key", "last-version", "multiline", "name", "new-version", "password", "token", "uid-token", "username", "value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateSecretVal from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateSecretVal from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accessibility": obj.get("accessibility") if obj.get("accessibility") is not None else 'regular',
            "custom-field": obj.get("custom-field"),
            "format": obj.get("format") if obj.get("format") is not None else 'text',
            "inject-url": obj.get("inject-url"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "keep-prev-version": obj.get("keep-prev-version"),
            "key": obj.get("key"),
            "last-version": obj.get("last-version"),
            "multiline": obj.get("multiline"),
            "name": obj.get("name"),
            "new-version": obj.get("new-version"),
            "password": obj.get("password"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "username": obj.get("username"),
            "value": obj.get("value")
        })
        return _obj


