# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UscCreate(BaseModel):
    """
    uscCreate is a command that creates a new secret in a Universal Secrets Connector
    """ # noqa: E501
    binary_value: Optional[StrictBool] = Field(default=None, description="Use this option if the universal secrets value is a base64 encoded binary", alias="binary-value")
    description: Optional[StrictStr] = Field(default=None, description="Description of the universal secrets")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    namespace: Optional[StrictStr] = Field(default=None, description="The namespace (relevant for Hashi vault target)")
    secret_name: StrictStr = Field(description="Name for the new universal secrets", alias="secret-name")
    tags: Optional[Dict[str, StrictStr]] = Field(default=None, description="Tags for the universal secrets")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    usc_name: StrictStr = Field(description="Name of the Universal Secrets Connector item", alias="usc-name")
    value: StrictStr = Field(description="Value of the universal secrets item, either text or base64 encoded binary")
    __properties: ClassVar[List[str]] = ["binary-value", "description", "json", "namespace", "secret-name", "tags", "token", "uid-token", "usc-name", "value"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UscCreate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UscCreate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "binary-value": obj.get("binary-value"),
            "description": obj.get("description"),
            "json": obj.get("json") if obj.get("json") is not None else False,
            "namespace": obj.get("namespace"),
            "secret-name": obj.get("secret-name"),
            "tags": obj.get("tags"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "usc-name": obj.get("usc-name"),
            "value": obj.get("value")
        })
        return _obj


