# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class VenafiTargetDetails(BaseModel):
    """
    VenafiTargetDetails
    """ # noqa: E501
    venafi_api_key: Optional[StrictStr] = None
    venafi_base_url: Optional[StrictStr] = None
    venafi_tpp_access_token: Optional[StrictStr] = None
    venafi_tpp_client_id: Optional[StrictStr] = None
    venafi_tpp_password: Optional[StrictStr] = Field(default=None, description="Deprecated: VenafiAccessToken and VenafiRefreshToken should be used instead")
    venafi_tpp_refresh_token: Optional[StrictStr] = None
    venafi_tpp_username: Optional[StrictStr] = Field(default=None, description="Deprecated: VenafiAccessToken and VenafiRefreshToken should be used instead")
    venafi_use_tpp: Optional[StrictBool] = None
    venafi_zone: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["venafi_api_key", "venafi_base_url", "venafi_tpp_access_token", "venafi_tpp_client_id", "venafi_tpp_password", "venafi_tpp_refresh_token", "venafi_tpp_username", "venafi_use_tpp", "venafi_zone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VenafiTargetDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VenafiTargetDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "venafi_api_key": obj.get("venafi_api_key"),
            "venafi_base_url": obj.get("venafi_base_url"),
            "venafi_tpp_access_token": obj.get("venafi_tpp_access_token"),
            "venafi_tpp_client_id": obj.get("venafi_tpp_client_id"),
            "venafi_tpp_password": obj.get("venafi_tpp_password"),
            "venafi_tpp_refresh_token": obj.get("venafi_tpp_refresh_token"),
            "venafi_tpp_username": obj.get("venafi_tpp_username"),
            "venafi_use_tpp": obj.get("venafi_use_tpp"),
            "venafi_zone": obj.get("venafi_zone")
        })
        return _obj


