# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class VerifyDataWithClassicKey(BaseModel):
    """
    VerifyDataWithClassicKey
    """ # noqa: E501
    data: StrictStr = Field(description="Data")
    display_id: Optional[StrictStr] = Field(default=None, description="The display id of the key to use in the verification process", alias="display-id")
    hashed: Optional[StrictBool] = Field(default=False, description="Defines whether the data should be hashed as part of the signing. If true, the data will not be hashed")
    hashing_method: Optional[StrictStr] = Field(default='SHA256', description="HashingMethod", alias="hashing-method")
    var_json: Optional[StrictBool] = Field(default=False, description="Set output format to JSON", alias="json")
    name: StrictStr = Field(description="The name of the key to use in the verification process")
    signature: StrictStr = Field(description="The data's signature in a Base64 format.")
    token: Optional[StrictStr] = Field(default=None, description="Authentication token (see `/auth` and `/configure`)")
    uid_token: Optional[StrictStr] = Field(default=None, description="The universal identity token, Required only for universal_identity authentication", alias="uid-token")
    version: StrictInt = Field(description="classic key version")
    __properties: ClassVar[List[str]] = ["data", "display-id", "hashed", "hashing-method", "json", "name", "signature", "token", "uid-token", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VerifyDataWithClassicKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VerifyDataWithClassicKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "data": obj.get("data"),
            "display-id": obj.get("display-id"),
            "hashed": obj.get("hashed") if obj.get("hashed") is not None else False,
            "hashing-method": obj.get("hashing-method") if obj.get("hashing-method") is not None else 'SHA256',
            "json": obj.get("json") if obj.get("json") is not None else False,
            "name": obj.get("name"),
            "signature": obj.get("signature"),
            "token": obj.get("token"),
            "uid-token": obj.get("uid-token"),
            "version": obj.get("version")
        })
        return _obj


