# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ActiveDirectoryPayload(BaseModel):
    """
    ActiveDirectoryPayload
    """ # noqa: E501
    active_directory_target_id: Optional[StrictInt] = None
    auto_rotate: Optional[StrictBool] = None
    auto_rotate_interval_in_days: Optional[StrictInt] = None
    auto_rotate_rotation_hour: Optional[StrictInt] = None
    computer_base_dn: Optional[StrictStr] = None
    discover_local_users: Optional[StrictBool] = Field(default=None, description="Deprecated")
    discover_services: Optional[StrictBool] = None
    discovery_types: Optional[List[StrictStr]] = None
    domain_name: Optional[StrictStr] = None
    domain_server_targets_path_template: Optional[StrictStr] = None
    domain_users_rotated_secrets_path_template: Optional[StrictStr] = None
    enable_rdp_sra: Optional[StrictBool] = None
    local_users_ignore_list: Optional[Dict[str, StrictBool]] = None
    local_users_rotated_secrets_path_template: Optional[StrictStr] = None
    os_filter: Optional[StrictStr] = None
    ssh_port: Optional[StrictStr] = None
    target_format: Optional[StrictStr] = None
    targets_type: Optional[StrictStr] = None
    user_base_dn: Optional[StrictStr] = None
    user_groups: Optional[List[StrictStr]] = None
    winrm_over_http: Optional[StrictBool] = None
    winrm_port: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["active_directory_target_id", "auto_rotate", "auto_rotate_interval_in_days", "auto_rotate_rotation_hour", "computer_base_dn", "discover_local_users", "discover_services", "discovery_types", "domain_name", "domain_server_targets_path_template", "domain_users_rotated_secrets_path_template", "enable_rdp_sra", "local_users_ignore_list", "local_users_rotated_secrets_path_template", "os_filter", "ssh_port", "target_format", "targets_type", "user_base_dn", "user_groups", "winrm_over_http", "winrm_port"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ActiveDirectoryPayload from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ActiveDirectoryPayload from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "active_directory_target_id": obj.get("active_directory_target_id"),
            "auto_rotate": obj.get("auto_rotate"),
            "auto_rotate_interval_in_days": obj.get("auto_rotate_interval_in_days"),
            "auto_rotate_rotation_hour": obj.get("auto_rotate_rotation_hour"),
            "computer_base_dn": obj.get("computer_base_dn"),
            "discover_local_users": obj.get("discover_local_users"),
            "discover_services": obj.get("discover_services"),
            "discovery_types": obj.get("discovery_types"),
            "domain_name": obj.get("domain_name"),
            "domain_server_targets_path_template": obj.get("domain_server_targets_path_template"),
            "domain_users_rotated_secrets_path_template": obj.get("domain_users_rotated_secrets_path_template"),
            "enable_rdp_sra": obj.get("enable_rdp_sra"),
            "local_users_ignore_list": obj.get("local_users_ignore_list"),
            "local_users_rotated_secrets_path_template": obj.get("local_users_rotated_secrets_path_template"),
            "os_filter": obj.get("os_filter"),
            "ssh_port": obj.get("ssh_port"),
            "target_format": obj.get("target_format"),
            "targets_type": obj.get("targets_type"),
            "user_base_dn": obj.get("user_base_dn"),
            "user_groups": obj.get("user_groups"),
            "winrm_over_http": obj.get("winrm_over_http"),
            "winrm_port": obj.get("winrm_port")
        })
        return _obj


